/* DragAndDropHandler.c generated by valac 0.56.17, the Vala compiler
 * generated from DragAndDropHandler.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/**/
/* DragAndDropHandler attaches signals to a Page to properly handle drag-and-drop requests for the*/
/* Page as a DnD Source.  (DnD Destination handling is handled by the appropriate AppWindow, i.e.*/
/* LibraryWindow and DirectWindow). Assumes the Page's ViewCollection holds MediaSources.*/
/**/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define APP_WINDOW_DND_ICON_SCALE 128
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DRAG_AND_DROP_HANDLER (drag_and_drop_handler_get_type ())
#define DRAG_AND_DROP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandler))
#define DRAG_AND_DROP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandlerClass))
#define IS_DRAG_AND_DROP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAG_AND_DROP_HANDLER))
#define IS_DRAG_AND_DROP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAG_AND_DROP_HANDLER))
#define DRAG_AND_DROP_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandlerClass))

typedef struct _DragAndDropHandler DragAndDropHandler;
typedef struct _DragAndDropHandlerClass DragAndDropHandlerClass;
typedef struct _DragAndDropHandlerPrivate DragAndDropHandlerPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_EXPORTER_UI (exporter_ui_get_type ())
#define EXPORTER_UI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTER_UI, ExporterUI))
#define EXPORTER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTER_UI, ExporterUIClass))
#define IS_EXPORTER_UI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTER_UI))
#define IS_EXPORTER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTER_UI))
#define EXPORTER_UI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTER_UI, ExporterUIClass))

typedef struct _ExporterUI ExporterUI;
typedef struct _ExporterUIClass ExporterUIClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS,
	DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST
} DragAndDropHandlerTargetType;

#define DRAG_AND_DROP_HANDLER_TYPE_TARGET_TYPE (drag_and_drop_handler_target_type_get_type ())
#define _exporter_ui_unref0(var) ((var == NULL) ? NULL : (var = (exporter_ui_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_AVIF,
	PHOTO_FILE_FORMAT_HEIF,
	PHOTO_FILE_FORMAT_JPEGXL,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_EXPORTER (exporter_get_type ())
#define EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTER, Exporter))
#define EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTER, ExporterClass))
#define IS_EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTER))
#define IS_EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTER))
#define EXPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTER, ExporterClass))

typedef struct _Exporter Exporter;
typedef struct _ExporterClass ExporterClass;
typedef void (*ExporterCompletionCallback) (Exporter* exporter, gboolean is_cancelled, gpointer user_data);
typedef struct _ParamSpecDragAndDropHandler ParamSpecDragAndDropHandler;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DragAndDropHandler {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DragAndDropHandlerPrivate * priv;
};

struct _DragAndDropHandlerClass {
	GTypeClass parent_class;
	void (*finalize) (DragAndDropHandler *self);
};

struct _DragAndDropHandlerPrivate {
	Page* page;
	GtkWidget* event_source;
	GFile* drag_destination;
	ExporterUI* exporter;
	GdkDragAction action;
};

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ParamSpecDragAndDropHandler {
	GParamSpec parent_instance;
};

static gint DragAndDropHandler_private_offset;
static gpointer drag_and_drop_handler_parent_class = NULL;
static GdkAtom* drag_and_drop_handler_XDS_ATOM;
static GdkAtom* drag_and_drop_handler_XDS_ATOM = NULL;
static GdkAtom* drag_and_drop_handler_TEXT_ATOM;
static GdkAtom* drag_and_drop_handler_TEXT_ATOM = NULL;
static guint8* drag_and_drop_handler_XDS_FAKE_TARGET;
static gint drag_and_drop_handler_XDS_FAKE_TARGET_length1;
static guint8* drag_and_drop_handler_XDS_FAKE_TARGET = NULL;
static gint drag_and_drop_handler_XDS_FAKE_TARGET_length1 = 0;
static gint _drag_and_drop_handler_XDS_FAKE_TARGET_size_ = 0;

VALA_EXTERN gpointer drag_and_drop_handler_ref (gpointer instance);
VALA_EXTERN void drag_and_drop_handler_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_drag_and_drop_handler (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void value_set_drag_and_drop_handler (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void value_take_drag_and_drop_handler (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer value_get_drag_and_drop_handler (const GValue* value);
VALA_EXTERN GType drag_and_drop_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DragAndDropHandler, drag_and_drop_handler_unref)
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
VALA_EXTERN gpointer exporter_ui_ref (gpointer instance);
VALA_EXTERN void exporter_ui_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_exporter_ui (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_exporter_ui (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_exporter_ui (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_exporter_ui (const GValue* value);
VALA_EXTERN GType exporter_ui_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExporterUI, exporter_ui_unref)
static void drag_and_drop_handler_on_drag_begin (DragAndDropHandler* self,
                                          GdkDragContext* context);
static void _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                 GdkDragContext* context,
                                                                 gpointer self);
static void drag_and_drop_handler_on_drag_data_get (DragAndDropHandler* self,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint target_type,
                                             guint time);
static void _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       GtkSelectionData* selection_data,
                                                                       guint info,
                                                                       guint time_,
                                                                       gpointer self);
static void drag_and_drop_handler_on_drag_end (DragAndDropHandler* self);
static void _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self);
static gboolean drag_and_drop_handler_on_drag_failed (DragAndDropHandler* self,
                                               GdkDragContext* context,
                                               GtkDragResult drag_result);
static gboolean _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender,
                                                                       GdkDragContext* context,
                                                                       GtkDragResult _result_,
                                                                       gpointer self);
static GType drag_and_drop_handler_target_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN DragAndDropHandler* drag_and_drop_handler_new (Page* page);
VALA_EXTERN DragAndDropHandler* drag_and_drop_handler_construct (GType object_type,
                                                     Page* page);
VALA_EXTERN GtkWidget* page_get_event_source (Page* self);
static GdkAtom* _gdk_atom_dup (GdkAtom* self);
VALA_EXTERN guchar* string_to_uchar_array (const gchar* str,
                               gint* result_length1);
VALA_EXTERN gchar* page_get_page_name (Page* self);
VALA_EXTERN gpointer data_collection_ref (gpointer instance);
VALA_EXTERN void data_collection_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_data_collection (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_data_collection (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_data_collection (const GValue* value);
VALA_EXTERN GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
VALA_EXTERN GType view_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewCollection, data_collection_unref)
VALA_EXTERN ViewCollection* page_get_view (Page* self);
VALA_EXTERN gint view_collection_get_selected_count (ViewCollection* self);
VALA_EXTERN GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
VALA_EXTERN GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
VALA_EXTERN GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
VALA_EXTERN GType data_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataView, g_object_unref)
VALA_EXTERN DataView* view_collection_get_selected_at (ViewCollection* self,
                                           gint index);
VALA_EXTERN DataSource* data_view_get_source (DataView* self);
VALA_EXTERN GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
VALA_EXTERN gchar* data_object_to_string (DataObject* self);
VALA_EXTERN gchar* uchar_array_to_string (guchar* data,
                              gint data_length1,
                              gint length);
VALA_EXTERN GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
VALA_EXTERN GeeList* view_collection_get_selected_sources (ViewCollection* self);
VALA_EXTERN guchar* serialize_media_sources (GeeCollection* media,
                                 gint* result_length1);
VALA_EXTERN GType export_format_parameters_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType export_format_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType photo_file_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType jpeg_quality_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
VALA_EXTERN void export_format_parameters_free (ExportFormatParameters* self);
VALA_EXTERN void export_format_parameters_current (ExportFormatParameters* result);
VALA_EXTERN void export_format_parameters_unmodified (ExportFormatParameters* result);
VALA_EXTERN GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
VALA_EXTERN GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
VALA_EXTERN GType scaling_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType scale_constraint_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN Scaling* scaling_dup (const Scaling* self);
VALA_EXTERN void scaling_free (Scaling* self);
VALA_EXTERN void scaling_for_original (Scaling* result);
VALA_EXTERN Exporter* exporter_new (GeeCollection* to_export,
                        GFile* dir,
                        Scaling* scaling,
                        ExportFormatParameters* export_params,
                        gboolean auto_replace_all);
VALA_EXTERN Exporter* exporter_construct (GType object_type,
                              GeeCollection* to_export,
                              GFile* dir,
                              Scaling* scaling,
                              ExportFormatParameters* export_params,
                              gboolean auto_replace_all);
VALA_EXTERN GType exporter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Exporter, g_object_unref)
VALA_EXTERN ExporterUI* exporter_ui_new (Exporter* exporter);
VALA_EXTERN ExporterUI* exporter_ui_construct (GType object_type,
                                   Exporter* exporter);
VALA_EXTERN void exporter_ui_export (ExporterUI* self,
                         ExporterCompletionCallback completion_callback,
                         gpointer completion_callback_target);
static void drag_and_drop_handler_on_export_completed (DragAndDropHandler* self);
static void _drag_and_drop_handler_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                              gboolean is_cancelled,
                                                                              gpointer self);
VALA_EXTERN void app_window_error_message (const gchar* message,
                               GtkWindow* parent);
static void drag_and_drop_handler_finalize (DragAndDropHandler * obj);
static GType drag_and_drop_handler_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GtkTargetEntry DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES[2] = {{"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS}, {"shotwell/media-id-atom", (guint) GTK_TARGET_SAME_APP, (guint) DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST}};

static inline gpointer
drag_and_drop_handler_get_instance_private (DragAndDropHandler* self)
{
	return G_STRUCT_MEMBER_P (self, DragAndDropHandler_private_offset);
}

static void
_drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                            GdkDragContext* context,
                                                            gpointer self)
{
#line 63 "../src/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_begin ((DragAndDropHandler*) self, context);
#line 470 "DragAndDropHandler.c"
}

static void
_drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                  GdkDragContext* context,
                                                                  GtkSelectionData* selection_data,
                                                                  guint info,
                                                                  guint time_,
                                                                  gpointer self)
{
#line 64 "../src/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_data_get ((DragAndDropHandler*) self, context, selection_data, info, time_);
#line 483 "DragAndDropHandler.c"
}

static void
_drag_and_drop_handler_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        gpointer self)
{
#line 65 "../src/DragAndDropHandler.vala"
	drag_and_drop_handler_on_drag_end ((DragAndDropHandler*) self);
#line 493 "DragAndDropHandler.c"
}

static gboolean
_drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              GtkDragResult _result_,
                                                              gpointer self)
{
	gboolean result;
	result = drag_and_drop_handler_on_drag_failed ((DragAndDropHandler*) self, context, _result_);
#line 66 "../src/DragAndDropHandler.vala"
	return result;
#line 506 "DragAndDropHandler.c"
}

static GType
drag_and_drop_handler_target_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS, "DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS", "xds"}, {DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST, "DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST", "media-list"}, {0, NULL, NULL}};
	GType drag_and_drop_handler_target_type_type_id;
	drag_and_drop_handler_target_type_type_id = g_enum_register_static ("DragAndDropHandlerTargetType", values);
	return drag_and_drop_handler_target_type_type_id;
}

static GType
drag_and_drop_handler_target_type_get_type (void)
{
	static volatile gsize drag_and_drop_handler_target_type_type_id__once = 0;
	if (g_once_init_enter (&drag_and_drop_handler_target_type_type_id__once)) {
		GType drag_and_drop_handler_target_type_type_id;
		drag_and_drop_handler_target_type_type_id = drag_and_drop_handler_target_type_get_type_once ();
		g_once_init_leave (&drag_and_drop_handler_target_type_type_id__once, drag_and_drop_handler_target_type_type_id);
	}
	return drag_and_drop_handler_target_type_type_id__once;
}

static GdkAtom*
_gdk_atom_dup (GdkAtom* self)
{
	GdkAtom* dup;
#line 41 "../src/DragAndDropHandler.vala"
	dup = g_new0 (GdkAtom, 1);
#line 41 "../src/DragAndDropHandler.vala"
	memcpy (dup, self, sizeof (GdkAtom));
#line 41 "../src/DragAndDropHandler.vala"
	return dup;
#line 540 "DragAndDropHandler.c"
}

static gpointer
__gdk_atom_dup0 (gpointer self)
{
#line 41 "../src/DragAndDropHandler.vala"
	return self ? _gdk_atom_dup (self) : NULL;
#line 548 "DragAndDropHandler.c"
}

DragAndDropHandler*
drag_and_drop_handler_construct (GType object_type,
                                 Page* page)
{
	DragAndDropHandler* self = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GdkAtom* _tmp3_;
	GdkAtom* _tmp6_;
	guint8* _tmp9_;
	gint _tmp9__length1;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkWidget* _tmp14_;
	GtkWidget* _tmp15_;
	GtkWidget* _tmp16_;
#line 33 "../src/DragAndDropHandler.vala"
	g_return_val_if_fail (IS_PAGE (page), NULL);
#line 33 "../src/DragAndDropHandler.vala"
	self = (DragAndDropHandler*) g_type_create_instance (object_type);
#line 34 "../src/DragAndDropHandler.vala"
	self->priv->page = page;
#line 35 "../src/DragAndDropHandler.vala"
	_tmp0_ = page_get_event_source (page);
#line 35 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 35 "../src/DragAndDropHandler.vala"
	self->priv->event_source = _tmp0_;
#line 36 "../src/DragAndDropHandler.vala"
	_tmp1_ = self->priv->event_source;
#line 36 "../src/DragAndDropHandler.vala"
	_vala_assert (_tmp1_ != NULL, "event_source != null");
#line 37 "../src/DragAndDropHandler.vala"
	_tmp2_ = self->priv->event_source;
#line 37 "../src/DragAndDropHandler.vala"
	_vala_assert (gtk_widget_get_has_window (_tmp2_), "event_source.get_has_window()");
#line 40 "../src/DragAndDropHandler.vala"
	_tmp3_ = drag_and_drop_handler_XDS_ATOM;
#line 40 "../src/DragAndDropHandler.vala"
	if (_tmp3_ == NULL) {
#line 592 "DragAndDropHandler.c"
		GdkAtom _tmp4_;
		GdkAtom* _tmp5_;
#line 41 "../src/DragAndDropHandler.vala"
		_tmp4_ = gdk_atom_intern_static_string ("XdndDirectSave0");
#line 41 "../src/DragAndDropHandler.vala"
		_tmp5_ = __gdk_atom_dup0 (&_tmp4_);
#line 41 "../src/DragAndDropHandler.vala"
		_g_free0 (drag_and_drop_handler_XDS_ATOM);
#line 41 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_XDS_ATOM = _tmp5_;
#line 603 "DragAndDropHandler.c"
	}
#line 43 "../src/DragAndDropHandler.vala"
	_tmp6_ = drag_and_drop_handler_TEXT_ATOM;
#line 43 "../src/DragAndDropHandler.vala"
	if (_tmp6_ == NULL) {
#line 609 "DragAndDropHandler.c"
		GdkAtom _tmp7_;
		GdkAtom* _tmp8_;
#line 44 "../src/DragAndDropHandler.vala"
		_tmp7_ = gdk_atom_intern_static_string ("text/plain");
#line 44 "../src/DragAndDropHandler.vala"
		_tmp8_ = __gdk_atom_dup0 (&_tmp7_);
#line 44 "../src/DragAndDropHandler.vala"
		_g_free0 (drag_and_drop_handler_TEXT_ATOM);
#line 44 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_TEXT_ATOM = _tmp8_;
#line 620 "DragAndDropHandler.c"
	}
#line 46 "../src/DragAndDropHandler.vala"
	_tmp9_ = drag_and_drop_handler_XDS_FAKE_TARGET;
#line 46 "../src/DragAndDropHandler.vala"
	_tmp9__length1 = drag_and_drop_handler_XDS_FAKE_TARGET_length1;
#line 46 "../src/DragAndDropHandler.vala"
	if (_tmp9_ == NULL) {
#line 628 "DragAndDropHandler.c"
		gint _tmp10_ = 0;
		guchar* _tmp11_;
#line 47 "../src/DragAndDropHandler.vala"
		_tmp11_ = string_to_uchar_array ("shotwell.txt", &_tmp10_);
#line 47 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_XDS_FAKE_TARGET = (g_free (drag_and_drop_handler_XDS_FAKE_TARGET), NULL);
#line 47 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_XDS_FAKE_TARGET = _tmp11_;
#line 47 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_XDS_FAKE_TARGET_length1 = _tmp10_;
#line 47 "../src/DragAndDropHandler.vala"
		_drag_and_drop_handler_XDS_FAKE_TARGET_size_ = drag_and_drop_handler_XDS_FAKE_TARGET_length1;
#line 641 "DragAndDropHandler.c"
	}
#line 50 "../src/DragAndDropHandler.vala"
	_tmp12_ = self->priv->event_source;
#line 50 "../src/DragAndDropHandler.vala"
	gtk_drag_source_set (_tmp12_, GDK_BUTTON1_MASK, DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES, (gint) G_N_ELEMENTS (DRAG_AND_DROP_HANDLER_SOURCE_TARGET_ENTRIES), GDK_ACTION_COPY | GDK_ACTION_MOVE);
#line 55 "../src/DragAndDropHandler.vala"
	_tmp13_ = self->priv->event_source;
#line 55 "../src/DragAndDropHandler.vala"
	g_signal_connect (_tmp13_, "drag-begin", (GCallback) _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin, self);
#line 56 "../src/DragAndDropHandler.vala"
	_tmp14_ = self->priv->event_source;
#line 56 "../src/DragAndDropHandler.vala"
	g_signal_connect (_tmp14_, "drag-data-get", (GCallback) _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get, self);
#line 57 "../src/DragAndDropHandler.vala"
	_tmp15_ = self->priv->event_source;
#line 57 "../src/DragAndDropHandler.vala"
	g_signal_connect (_tmp15_, "drag-end", (GCallback) _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end, self);
#line 58 "../src/DragAndDropHandler.vala"
	_tmp16_ = self->priv->event_source;
#line 58 "../src/DragAndDropHandler.vala"
	g_signal_connect (_tmp16_, "drag-failed", (GCallback) _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed, self);
#line 33 "../src/DragAndDropHandler.vala"
	return self;
#line 665 "DragAndDropHandler.c"
}

DragAndDropHandler*
drag_and_drop_handler_new (Page* page)
{
#line 33 "../src/DragAndDropHandler.vala"
	return drag_and_drop_handler_construct (TYPE_DRAG_AND_DROP_HANDLER, page);
#line 673 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_on_drag_begin (DragAndDropHandler* self,
                                     GdkDragContext* context)
{
	Page* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	ThumbnailSource* thumb = NULL;
	Page* _tmp10_;
	ViewCollection* _tmp11_;
	ViewCollection* _tmp12_;
	DataView* _tmp13_;
	DataView* _tmp14_;
	DataSource* _tmp15_;
	ThumbnailSource* _tmp16_;
	GdkWindow* _tmp26_;
	GdkAtom* _tmp27_;
	GdkAtom* _tmp28_;
	guint8* _tmp29_;
	gint _tmp29__length1;
	GError* _inner_error0_ = NULL;
#line 73 "../src/DragAndDropHandler.vala"
	g_return_if_fail (IS_DRAG_AND_DROP_HANDLER (self));
#line 73 "../src/DragAndDropHandler.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (context, gdk_drag_context_get_type ()));
#line 74 "../src/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 74 "../src/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 74 "../src/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 74 "../src/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:74: on_drag_begin (%s)", _tmp2_);
#line 74 "../src/DragAndDropHandler.vala"
	_g_free0 (_tmp2_);
#line 76 "../src/DragAndDropHandler.vala"
	_tmp5_ = self->priv->page;
#line 76 "../src/DragAndDropHandler.vala"
	if (_tmp5_ == NULL) {
#line 76 "../src/DragAndDropHandler.vala"
		_tmp4_ = TRUE;
#line 720 "DragAndDropHandler.c"
	} else {
		Page* _tmp6_;
		ViewCollection* _tmp7_;
		ViewCollection* _tmp8_;
#line 76 "../src/DragAndDropHandler.vala"
		_tmp6_ = self->priv->page;
#line 76 "../src/DragAndDropHandler.vala"
		_tmp7_ = page_get_view (_tmp6_);
#line 76 "../src/DragAndDropHandler.vala"
		_tmp8_ = _tmp7_;
#line 76 "../src/DragAndDropHandler.vala"
		_tmp4_ = view_collection_get_selected_count (_tmp8_) == 0;
#line 76 "../src/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp8_);
#line 735 "DragAndDropHandler.c"
	}
#line 76 "../src/DragAndDropHandler.vala"
	if (_tmp4_) {
#line 76 "../src/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 741 "DragAndDropHandler.c"
	} else {
		ExporterUI* _tmp9_;
#line 76 "../src/DragAndDropHandler.vala"
		_tmp9_ = self->priv->exporter;
#line 76 "../src/DragAndDropHandler.vala"
		_tmp3_ = _tmp9_ != NULL;
#line 748 "DragAndDropHandler.c"
	}
#line 76 "../src/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 77 "../src/DragAndDropHandler.vala"
		return;
#line 754 "DragAndDropHandler.c"
	}
#line 79 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 79 "../src/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 82 "../src/DragAndDropHandler.vala"
	_tmp10_ = self->priv->page;
#line 82 "../src/DragAndDropHandler.vala"
	_tmp11_ = page_get_view (_tmp10_);
#line 82 "../src/DragAndDropHandler.vala"
	_tmp12_ = _tmp11_;
#line 82 "../src/DragAndDropHandler.vala"
	_tmp13_ = view_collection_get_selected_at (_tmp12_, 0);
#line 82 "../src/DragAndDropHandler.vala"
	_tmp14_ = _tmp13_;
#line 82 "../src/DragAndDropHandler.vala"
	_tmp15_ = data_view_get_source (_tmp14_);
#line 82 "../src/DragAndDropHandler.vala"
	_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource);
#line 82 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (_tmp14_);
#line 82 "../src/DragAndDropHandler.vala"
	_data_collection_unref0 (_tmp12_);
#line 82 "../src/DragAndDropHandler.vala"
	thumb = _tmp16_;
#line 780 "DragAndDropHandler.c"
	{
		GdkPixbuf* icon = NULL;
		ThumbnailSource* _tmp17_;
		GdkPixbuf* _tmp18_;
		GtkWidget* _tmp19_;
		GdkPixbuf* _tmp20_;
#line 85 "../src/DragAndDropHandler.vala"
		_tmp17_ = thumb;
#line 85 "../src/DragAndDropHandler.vala"
		_tmp18_ = thumbnail_source_get_thumbnail (_tmp17_, APP_WINDOW_DND_ICON_SCALE, &_inner_error0_);
#line 85 "../src/DragAndDropHandler.vala"
		icon = _tmp18_;
#line 85 "../src/DragAndDropHandler.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 795 "DragAndDropHandler.c"
			goto __catch0_g_error;
		}
#line 86 "../src/DragAndDropHandler.vala"
		_tmp19_ = self->priv->event_source;
#line 86 "../src/DragAndDropHandler.vala"
		_tmp20_ = icon;
#line 86 "../src/DragAndDropHandler.vala"
		gtk_drag_source_set_icon_pixbuf (_tmp19_, _tmp20_);
#line 84 "../src/DragAndDropHandler.vala"
		_g_object_unref0 (icon);
#line 806 "DragAndDropHandler.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		ThumbnailSource* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 84 "../src/DragAndDropHandler.vala"
		err = _inner_error0_;
#line 84 "../src/DragAndDropHandler.vala"
		_inner_error0_ = NULL;
#line 88 "../src/DragAndDropHandler.vala"
		_tmp21_ = thumb;
#line 88 "../src/DragAndDropHandler.vala"
		_tmp22_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_DATA_OBJECT, DataObject));
#line 88 "../src/DragAndDropHandler.vala"
		_tmp23_ = _tmp22_;
#line 88 "../src/DragAndDropHandler.vala"
		_tmp24_ = err;
#line 88 "../src/DragAndDropHandler.vala"
		_tmp25_ = _tmp24_->message;
#line 88 "../src/DragAndDropHandler.vala"
		g_warning ("DragAndDropHandler.vala:88: Unable to fetch icon for drag-and-drop fro" \
"m %s: %s", _tmp23_, _tmp25_);
#line 88 "../src/DragAndDropHandler.vala"
		_g_free0 (_tmp23_);
#line 84 "../src/DragAndDropHandler.vala"
		_g_error_free0 (err);
#line 837 "DragAndDropHandler.c"
	}
	__finally0:
#line 84 "../src/DragAndDropHandler.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/DragAndDropHandler.vala"
		_g_object_unref0 (thumb);
#line 84 "../src/DragAndDropHandler.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/DragAndDropHandler.vala"
		g_clear_error (&_inner_error0_);
#line 84 "../src/DragAndDropHandler.vala"
		return;
#line 850 "DragAndDropHandler.c"
	}
#line 93 "../src/DragAndDropHandler.vala"
	_tmp26_ = gdk_drag_context_get_source_window (context);
#line 93 "../src/DragAndDropHandler.vala"
	_tmp27_ = drag_and_drop_handler_XDS_ATOM;
#line 93 "../src/DragAndDropHandler.vala"
	_tmp28_ = drag_and_drop_handler_TEXT_ATOM;
#line 93 "../src/DragAndDropHandler.vala"
	_tmp29_ = drag_and_drop_handler_XDS_FAKE_TARGET;
#line 93 "../src/DragAndDropHandler.vala"
	_tmp29__length1 = drag_and_drop_handler_XDS_FAKE_TARGET_length1;
#line 93 "../src/DragAndDropHandler.vala"
	gdk_property_change (_tmp26_, *_tmp27_, *_tmp28_, 8, GDK_PROP_MODE_REPLACE, (const guchar*) _tmp29_, 1);
#line 73 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (thumb);
#line 866 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_on_drag_data_get (DragAndDropHandler* self,
                                        GdkDragContext* context,
                                        GtkSelectionData* selection_data,
                                        guint target_type,
                                        guint time)
{
	Page* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Page* _tmp4_;
#line 97 "../src/DragAndDropHandler.vala"
	g_return_if_fail (IS_DRAG_AND_DROP_HANDLER (self));
#line 97 "../src/DragAndDropHandler.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (context, gdk_drag_context_get_type ()));
#line 97 "../src/DragAndDropHandler.vala"
	g_return_if_fail (selection_data != NULL);
#line 99 "../src/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 99 "../src/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 99 "../src/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 99 "../src/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:99: on_drag_data_get (%s)", _tmp2_);
#line 99 "../src/DragAndDropHandler.vala"
	_g_free0 (_tmp2_);
#line 101 "../src/DragAndDropHandler.vala"
	_tmp4_ = self->priv->page;
#line 101 "../src/DragAndDropHandler.vala"
	if (_tmp4_ == NULL) {
#line 101 "../src/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 903 "DragAndDropHandler.c"
	} else {
		Page* _tmp5_;
		ViewCollection* _tmp6_;
		ViewCollection* _tmp7_;
#line 101 "../src/DragAndDropHandler.vala"
		_tmp5_ = self->priv->page;
#line 101 "../src/DragAndDropHandler.vala"
		_tmp6_ = page_get_view (_tmp5_);
#line 101 "../src/DragAndDropHandler.vala"
		_tmp7_ = _tmp6_;
#line 101 "../src/DragAndDropHandler.vala"
		_tmp3_ = view_collection_get_selected_count (_tmp7_) == 0;
#line 101 "../src/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp7_);
#line 918 "DragAndDropHandler.c"
	}
#line 101 "../src/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 102 "../src/DragAndDropHandler.vala"
		return;
#line 924 "DragAndDropHandler.c"
	}
#line 104 "../src/DragAndDropHandler.vala"
	self->priv->action = gdk_drag_context_get_suggested_action (context);
#line 106 "../src/DragAndDropHandler.vala"
	switch (target_type) {
#line 106 "../src/DragAndDropHandler.vala"
		case DRAG_AND_DROP_HANDLER_TARGET_TYPE_XDS:
#line 932 "DragAndDropHandler.c"
		{
			guchar* data = NULL;
			guchar* _tmp8_;
			gint data_length1;
			gint _data_size_;
			GdkAtom actual_type = (GdkAtom) 0U;
			gint actual_format = 0;
			gboolean fetched = FALSE;
			GdkWindow* _tmp9_;
			GdkAtom* _tmp10_;
			GdkAtom* _tmp11_;
			guchar* _tmp12_;
			gint _tmp12__length1;
			GdkAtom _tmp13_ = (GdkAtom) 0U;
			gint _tmp14_ = 0;
			guint8* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gboolean _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gchar* _tmp28_ = NULL;
			GFile* _tmp29_;
			Page* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			const gchar* _tmp36_ = NULL;
			GFile* _tmp37_;
			GdkAtom* _tmp38_;
			gint _tmp39_ = 0;
			guchar* _tmp40_;
			guchar* _tmp41_;
			gint _tmp41__length1;
#line 109 "../src/DragAndDropHandler.vala"
			_tmp8_ = g_new0 (guchar, 4096);
#line 109 "../src/DragAndDropHandler.vala"
			data = _tmp8_;
#line 109 "../src/DragAndDropHandler.vala"
			data_length1 = 4096;
#line 109 "../src/DragAndDropHandler.vala"
			_data_size_ = data_length1;
#line 111 "../src/DragAndDropHandler.vala"
			actual_format = 0;
#line 112 "../src/DragAndDropHandler.vala"
			_tmp9_ = gdk_drag_context_get_source_window (context);
#line 112 "../src/DragAndDropHandler.vala"
			_tmp10_ = drag_and_drop_handler_XDS_ATOM;
#line 112 "../src/DragAndDropHandler.vala"
			_tmp11_ = drag_and_drop_handler_TEXT_ATOM;
#line 112 "../src/DragAndDropHandler.vala"
			_tmp12_ = data;
#line 112 "../src/DragAndDropHandler.vala"
			_tmp12__length1 = data_length1;
#line 112 "../src/DragAndDropHandler.vala"
			_tmp17_ = gdk_property_get (_tmp9_, *_tmp10_, *_tmp11_, (gulong) 0, (gulong) _tmp12__length1, 0, &_tmp13_, &_tmp14_, &_tmp16_, &_tmp15_);
#line 112 "../src/DragAndDropHandler.vala"
			actual_type = _tmp13_;
#line 112 "../src/DragAndDropHandler.vala"
			actual_format = _tmp14_;
#line 112 "../src/DragAndDropHandler.vala"
			data = (g_free (data), NULL);
#line 112 "../src/DragAndDropHandler.vala"
			data = _tmp15_;
#line 112 "../src/DragAndDropHandler.vala"
			data_length1 = _tmp16_;
#line 112 "../src/DragAndDropHandler.vala"
			_data_size_ = data_length1;
#line 112 "../src/DragAndDropHandler.vala"
			fetched = _tmp17_;
#line 117 "../src/DragAndDropHandler.vala"
			if (fetched) {
#line 1003 "DragAndDropHandler.c"
				guchar* _tmp20_;
				gint _tmp20__length1;
#line 117 "../src/DragAndDropHandler.vala"
				_tmp20_ = data;
#line 117 "../src/DragAndDropHandler.vala"
				_tmp20__length1 = data_length1;
#line 117 "../src/DragAndDropHandler.vala"
				_tmp19_ = _tmp20_ != NULL;
#line 1012 "DragAndDropHandler.c"
			} else {
#line 117 "../src/DragAndDropHandler.vala"
				_tmp19_ = FALSE;
#line 1016 "DragAndDropHandler.c"
			}
#line 117 "../src/DragAndDropHandler.vala"
			if (_tmp19_) {
#line 1020 "DragAndDropHandler.c"
				guchar* _tmp21_;
				gint _tmp21__length1;
#line 117 "../src/DragAndDropHandler.vala"
				_tmp21_ = data;
#line 117 "../src/DragAndDropHandler.vala"
				_tmp21__length1 = data_length1;
#line 117 "../src/DragAndDropHandler.vala"
				_tmp18_ = _tmp21__length1 > 0;
#line 1029 "DragAndDropHandler.c"
			} else {
#line 117 "../src/DragAndDropHandler.vala"
				_tmp18_ = FALSE;
#line 1033 "DragAndDropHandler.c"
			}
#line 117 "../src/DragAndDropHandler.vala"
			if (_tmp18_) {
#line 1037 "DragAndDropHandler.c"
				guchar* _tmp22_;
				gint _tmp22__length1;
				gchar* _tmp23_;
				gchar* _tmp24_;
				GFile* _tmp25_;
				GFile* _tmp26_;
				GFile* _tmp27_;
#line 118 "../src/DragAndDropHandler.vala"
				_tmp22_ = data;
#line 118 "../src/DragAndDropHandler.vala"
				_tmp22__length1 = data_length1;
#line 118 "../src/DragAndDropHandler.vala"
				_tmp23_ = uchar_array_to_string (_tmp22_, (gint) _tmp22__length1, -1);
#line 118 "../src/DragAndDropHandler.vala"
				_tmp24_ = _tmp23_;
#line 118 "../src/DragAndDropHandler.vala"
				_tmp25_ = g_file_new_for_uri (_tmp24_);
#line 118 "../src/DragAndDropHandler.vala"
				_tmp26_ = _tmp25_;
#line 118 "../src/DragAndDropHandler.vala"
				_tmp27_ = g_file_get_parent (_tmp26_);
#line 118 "../src/DragAndDropHandler.vala"
				_g_object_unref0 (self->priv->drag_destination);
#line 118 "../src/DragAndDropHandler.vala"
				self->priv->drag_destination = _tmp27_;
#line 118 "../src/DragAndDropHandler.vala"
				_g_object_unref0 (_tmp26_);
#line 118 "../src/DragAndDropHandler.vala"
				_g_free0 (_tmp24_);
#line 1067 "DragAndDropHandler.c"
			}
#line 121 "../src/DragAndDropHandler.vala"
			_tmp29_ = self->priv->drag_destination;
#line 121 "../src/DragAndDropHandler.vala"
			if (_tmp29_ != NULL) {
#line 1073 "DragAndDropHandler.c"
				GFile* _tmp30_;
				gchar* _tmp31_;
#line 121 "../src/DragAndDropHandler.vala"
				_tmp30_ = self->priv->drag_destination;
#line 121 "../src/DragAndDropHandler.vala"
				_tmp31_ = g_file_get_path (_tmp30_);
#line 121 "../src/DragAndDropHandler.vala"
				_g_free0 (_tmp28_);
#line 121 "../src/DragAndDropHandler.vala"
				_tmp28_ = _tmp31_;
#line 1084 "DragAndDropHandler.c"
			} else {
				gchar* _tmp32_;
#line 121 "../src/DragAndDropHandler.vala"
				_tmp32_ = g_strdup ("(no path)");
#line 121 "../src/DragAndDropHandler.vala"
				_g_free0 (_tmp28_);
#line 121 "../src/DragAndDropHandler.vala"
				_tmp28_ = _tmp32_;
#line 1093 "DragAndDropHandler.c"
			}
#line 120 "../src/DragAndDropHandler.vala"
			_tmp33_ = self->priv->page;
#line 120 "../src/DragAndDropHandler.vala"
			_tmp34_ = page_get_page_name (_tmp33_);
#line 120 "../src/DragAndDropHandler.vala"
			_tmp35_ = _tmp34_;
#line 120 "../src/DragAndDropHandler.vala"
			g_debug ("DragAndDropHandler.vala:120: on_drag_data_get (%s): %s", _tmp35_, _tmp28_);
#line 120 "../src/DragAndDropHandler.vala"
			_g_free0 (_tmp35_);
#line 125 "../src/DragAndDropHandler.vala"
			_tmp37_ = self->priv->drag_destination;
#line 125 "../src/DragAndDropHandler.vala"
			if (_tmp37_ != NULL) {
#line 125 "../src/DragAndDropHandler.vala"
				_tmp36_ = "S";
#line 1111 "DragAndDropHandler.c"
			} else {
#line 125 "../src/DragAndDropHandler.vala"
				_tmp36_ = "E";
#line 1115 "DragAndDropHandler.c"
			}
#line 124 "../src/DragAndDropHandler.vala"
			_tmp38_ = drag_and_drop_handler_XDS_ATOM;
#line 124 "../src/DragAndDropHandler.vala"
			_tmp40_ = string_to_uchar_array (_tmp36_, &_tmp39_);
#line 124 "../src/DragAndDropHandler.vala"
			_tmp41_ = _tmp40_;
#line 124 "../src/DragAndDropHandler.vala"
			_tmp41__length1 = _tmp39_;
#line 124 "../src/DragAndDropHandler.vala"
			gtk_selection_data_set (selection_data, *_tmp38_, 8, _tmp41_, (gint) _tmp39_);
#line 124 "../src/DragAndDropHandler.vala"
			_tmp41_ = (g_free (_tmp41_), NULL);
#line 126 "../src/DragAndDropHandler.vala"
			_g_free0 (_tmp28_);
#line 126 "../src/DragAndDropHandler.vala"
			data = (g_free (data), NULL);
#line 126 "../src/DragAndDropHandler.vala"
			break;
#line 1135 "DragAndDropHandler.c"
		}
#line 106 "../src/DragAndDropHandler.vala"
		case DRAG_AND_DROP_HANDLER_TARGET_TYPE_MEDIA_LIST:
#line 1139 "DragAndDropHandler.c"
		{
			GeeCollection* sources = NULL;
			Page* _tmp42_;
			ViewCollection* _tmp43_;
			ViewCollection* _tmp44_;
			GeeList* _tmp45_;
			GeeCollection* _tmp46_;
			GeeCollection* _tmp47_;
			gint _tmp48_ = 0;
			guchar* _tmp49_;
			guchar* _tmp50_;
			gint _tmp50__length1;
#line 129 "../src/DragAndDropHandler.vala"
			_tmp42_ = self->priv->page;
#line 129 "../src/DragAndDropHandler.vala"
			_tmp43_ = page_get_view (_tmp42_);
#line 129 "../src/DragAndDropHandler.vala"
			_tmp44_ = _tmp43_;
#line 129 "../src/DragAndDropHandler.vala"
			_tmp45_ = view_collection_get_selected_sources (_tmp44_);
#line 129 "../src/DragAndDropHandler.vala"
			_tmp46_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_COLLECTION, GeeCollection);
#line 129 "../src/DragAndDropHandler.vala"
			_data_collection_unref0 (_tmp44_);
#line 129 "../src/DragAndDropHandler.vala"
			sources = _tmp46_;
#line 134 "../src/DragAndDropHandler.vala"
			_tmp47_ = sources;
#line 134 "../src/DragAndDropHandler.vala"
			_tmp49_ = serialize_media_sources (_tmp47_, &_tmp48_);
#line 134 "../src/DragAndDropHandler.vala"
			_tmp50_ = _tmp49_;
#line 134 "../src/DragAndDropHandler.vala"
			_tmp50__length1 = _tmp48_;
#line 134 "../src/DragAndDropHandler.vala"
			gtk_selection_data_set (selection_data, gdk_atom_intern_static_string ("SourceIDAtom"), (gint) sizeof (GdkAtom), _tmp50_, (gint) _tmp48_);
#line 134 "../src/DragAndDropHandler.vala"
			_tmp50_ = (g_free (_tmp50_), NULL);
#line 136 "../src/DragAndDropHandler.vala"
			_g_object_unref0 (sources);
#line 136 "../src/DragAndDropHandler.vala"
			break;
#line 1182 "DragAndDropHandler.c"
		}
		default:
		{
			Page* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
#line 139 "../src/DragAndDropHandler.vala"
			_tmp51_ = self->priv->page;
#line 139 "../src/DragAndDropHandler.vala"
			_tmp52_ = page_get_page_name (_tmp51_);
#line 139 "../src/DragAndDropHandler.vala"
			_tmp53_ = _tmp52_;
#line 139 "../src/DragAndDropHandler.vala"
			g_warning ("DragAndDropHandler.vala:139: on_drag_data_get (%s): unknown target typ" \
"e %u", _tmp53_, target_type);
#line 139 "../src/DragAndDropHandler.vala"
			_g_free0 (_tmp53_);
#line 141 "../src/DragAndDropHandler.vala"
			break;
#line 1201 "DragAndDropHandler.c"
		}
	}
}

static void
_drag_and_drop_handler_on_export_completed_exporter_completion_callback (Exporter* exporter,
                                                                         gboolean is_cancelled,
                                                                         gpointer self)
{
#line 163 "../src/DragAndDropHandler.vala"
	drag_and_drop_handler_on_export_completed ((DragAndDropHandler*) self);
#line 1213 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_on_drag_end (DragAndDropHandler* self)
{
	Page* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	Page* _tmp6_;
	const gchar* _tmp12_ = NULL;
	GFile* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFile* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gboolean _tmp19_;
#line 145 "../src/DragAndDropHandler.vala"
	g_return_if_fail (IS_DRAG_AND_DROP_HANDLER (self));
#line 146 "../src/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 146 "../src/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 146 "../src/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 146 "../src/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:146: on_drag_end (%s)", _tmp2_);
#line 146 "../src/DragAndDropHandler.vala"
	_g_free0 (_tmp2_);
#line 148 "../src/DragAndDropHandler.vala"
	_tmp6_ = self->priv->page;
#line 148 "../src/DragAndDropHandler.vala"
	if (_tmp6_ == NULL) {
#line 148 "../src/DragAndDropHandler.vala"
		_tmp5_ = TRUE;
#line 1252 "DragAndDropHandler.c"
	} else {
		Page* _tmp7_;
		ViewCollection* _tmp8_;
		ViewCollection* _tmp9_;
#line 148 "../src/DragAndDropHandler.vala"
		_tmp7_ = self->priv->page;
#line 148 "../src/DragAndDropHandler.vala"
		_tmp8_ = page_get_view (_tmp7_);
#line 148 "../src/DragAndDropHandler.vala"
		_tmp9_ = _tmp8_;
#line 148 "../src/DragAndDropHandler.vala"
		_tmp5_ = view_collection_get_selected_count (_tmp9_) == 0;
#line 148 "../src/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp9_);
#line 1267 "DragAndDropHandler.c"
	}
#line 148 "../src/DragAndDropHandler.vala"
	if (_tmp5_) {
#line 148 "../src/DragAndDropHandler.vala"
		_tmp4_ = TRUE;
#line 1273 "DragAndDropHandler.c"
	} else {
		GFile* _tmp10_;
#line 148 "../src/DragAndDropHandler.vala"
		_tmp10_ = self->priv->drag_destination;
#line 148 "../src/DragAndDropHandler.vala"
		_tmp4_ = _tmp10_ == NULL;
#line 1280 "DragAndDropHandler.c"
	}
#line 148 "../src/DragAndDropHandler.vala"
	if (_tmp4_) {
#line 148 "../src/DragAndDropHandler.vala"
		_tmp3_ = TRUE;
#line 1286 "DragAndDropHandler.c"
	} else {
		ExporterUI* _tmp11_;
#line 149 "../src/DragAndDropHandler.vala"
		_tmp11_ = self->priv->exporter;
#line 149 "../src/DragAndDropHandler.vala"
		_tmp3_ = _tmp11_ != NULL;
#line 1293 "DragAndDropHandler.c"
	}
#line 148 "../src/DragAndDropHandler.vala"
	if (_tmp3_) {
#line 150 "../src/DragAndDropHandler.vala"
		return;
#line 1299 "DragAndDropHandler.c"
	}
#line 153 "../src/DragAndDropHandler.vala"
	if (self->priv->action == GDK_ACTION_COPY) {
#line 153 "../src/DragAndDropHandler.vala"
		_tmp12_ = "current";
#line 1305 "DragAndDropHandler.c"
	} else {
#line 153 "../src/DragAndDropHandler.vala"
		_tmp12_ = "unmodified";
#line 1309 "DragAndDropHandler.c"
	}
#line 153 "../src/DragAndDropHandler.vala"
	_tmp13_ = self->priv->drag_destination;
#line 153 "../src/DragAndDropHandler.vala"
	_tmp14_ = g_file_get_path (_tmp13_);
#line 153 "../src/DragAndDropHandler.vala"
	_tmp15_ = _tmp14_;
#line 153 "../src/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:153: Exporting to %s, mode %s", _tmp15_, _tmp12_);
#line 153 "../src/DragAndDropHandler.vala"
	_g_free0 (_tmp15_);
#line 158 "../src/DragAndDropHandler.vala"
	_tmp16_ = self->priv->drag_destination;
#line 158 "../src/DragAndDropHandler.vala"
	_tmp17_ = g_file_get_path (_tmp16_);
#line 158 "../src/DragAndDropHandler.vala"
	_tmp18_ = _tmp17_;
#line 158 "../src/DragAndDropHandler.vala"
	_tmp19_ = _tmp18_ != NULL;
#line 158 "../src/DragAndDropHandler.vala"
	_g_free0 (_tmp18_);
#line 158 "../src/DragAndDropHandler.vala"
	if (_tmp19_) {
#line 1333 "DragAndDropHandler.c"
		ExportFormatParameters _tmp20_ = {0};
		Page* _tmp23_;
		ViewCollection* _tmp24_;
		ViewCollection* _tmp25_;
		GeeList* _tmp26_;
		GeeCollection* _tmp27_;
		GFile* _tmp28_;
		Scaling _tmp29_ = {0};
		Exporter* _tmp30_;
		Exporter* _tmp31_;
		ExporterUI* _tmp32_;
		ExporterUI* _tmp33_;
#line 161 "../src/DragAndDropHandler.vala"
		if (self->priv->action == GDK_ACTION_COPY) {
#line 1348 "DragAndDropHandler.c"
			ExportFormatParameters _tmp21_ = {0};
#line 161 "../src/DragAndDropHandler.vala"
			export_format_parameters_current (&_tmp21_);
#line 161 "../src/DragAndDropHandler.vala"
			_tmp20_ = _tmp21_;
#line 1354 "DragAndDropHandler.c"
		} else {
			ExportFormatParameters _tmp22_ = {0};
#line 162 "../src/DragAndDropHandler.vala"
			export_format_parameters_unmodified (&_tmp22_);
#line 162 "../src/DragAndDropHandler.vala"
			_tmp20_ = _tmp22_;
#line 1361 "DragAndDropHandler.c"
		}
#line 159 "../src/DragAndDropHandler.vala"
		_tmp23_ = self->priv->page;
#line 159 "../src/DragAndDropHandler.vala"
		_tmp24_ = page_get_view (_tmp23_);
#line 159 "../src/DragAndDropHandler.vala"
		_tmp25_ = _tmp24_;
#line 159 "../src/DragAndDropHandler.vala"
		_tmp26_ = view_collection_get_selected_sources (_tmp25_);
#line 159 "../src/DragAndDropHandler.vala"
		_tmp27_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection);
#line 159 "../src/DragAndDropHandler.vala"
		_tmp28_ = self->priv->drag_destination;
#line 159 "../src/DragAndDropHandler.vala"
		scaling_for_original (&_tmp29_);
#line 159 "../src/DragAndDropHandler.vala"
		_tmp30_ = exporter_new (_tmp27_, _tmp28_, &_tmp29_, &_tmp20_, FALSE);
#line 159 "../src/DragAndDropHandler.vala"
		_tmp31_ = _tmp30_;
#line 159 "../src/DragAndDropHandler.vala"
		_tmp32_ = exporter_ui_new (_tmp31_);
#line 159 "../src/DragAndDropHandler.vala"
		_exporter_ui_unref0 (self->priv->exporter);
#line 159 "../src/DragAndDropHandler.vala"
		self->priv->exporter = _tmp32_;
#line 159 "../src/DragAndDropHandler.vala"
		_g_object_unref0 (_tmp31_);
#line 159 "../src/DragAndDropHandler.vala"
		_g_object_unref0 (_tmp27_);
#line 159 "../src/DragAndDropHandler.vala"
		_data_collection_unref0 (_tmp25_);
#line 163 "../src/DragAndDropHandler.vala"
		_tmp33_ = self->priv->exporter;
#line 163 "../src/DragAndDropHandler.vala"
		exporter_ui_export (_tmp33_, _drag_and_drop_handler_on_export_completed_exporter_completion_callback, self);
#line 1397 "DragAndDropHandler.c"
	} else {
#line 165 "../src/DragAndDropHandler.vala"
		app_window_error_message (_ ("Photos cannot be exported to this directory."), NULL);
#line 1401 "DragAndDropHandler.c"
	}
#line 168 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 168 "../src/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 1407 "DragAndDropHandler.c"
}

static gboolean
drag_and_drop_handler_on_drag_failed (DragAndDropHandler* self,
                                      GdkDragContext* context,
                                      GtkDragResult drag_result)
{
	Page* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	Page* _tmp3_;
	gboolean result;
#line 171 "../src/DragAndDropHandler.vala"
	g_return_val_if_fail (IS_DRAG_AND_DROP_HANDLER (self), FALSE);
#line 171 "../src/DragAndDropHandler.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (context, gdk_drag_context_get_type ()), FALSE);
#line 172 "../src/DragAndDropHandler.vala"
	_tmp0_ = self->priv->page;
#line 172 "../src/DragAndDropHandler.vala"
	_tmp1_ = page_get_page_name (_tmp0_);
#line 172 "../src/DragAndDropHandler.vala"
	_tmp2_ = _tmp1_;
#line 172 "../src/DragAndDropHandler.vala"
	g_debug ("DragAndDropHandler.vala:172: on_drag_failed (%s): %d", _tmp2_, (gint) drag_result);
#line 172 "../src/DragAndDropHandler.vala"
	_g_free0 (_tmp2_);
#line 174 "../src/DragAndDropHandler.vala"
	_tmp3_ = self->priv->page;
#line 174 "../src/DragAndDropHandler.vala"
	if (_tmp3_ == NULL) {
#line 175 "../src/DragAndDropHandler.vala"
		result = FALSE;
#line 175 "../src/DragAndDropHandler.vala"
		return result;
#line 1442 "DragAndDropHandler.c"
	}
#line 177 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 177 "../src/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 179 "../src/DragAndDropHandler.vala"
	result = FALSE;
#line 179 "../src/DragAndDropHandler.vala"
	return result;
#line 1452 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_on_export_completed (DragAndDropHandler* self)
{
#line 182 "../src/DragAndDropHandler.vala"
	g_return_if_fail (IS_DRAG_AND_DROP_HANDLER (self));
#line 183 "../src/DragAndDropHandler.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 183 "../src/DragAndDropHandler.vala"
	self->priv->exporter = NULL;
#line 1464 "DragAndDropHandler.c"
}

static void
value_drag_and_drop_handler_init (GValue* value)
{
#line 12 "../src/DragAndDropHandler.vala"
	value->data[0].v_pointer = NULL;
#line 1472 "DragAndDropHandler.c"
}

static void
value_drag_and_drop_handler_free_value (GValue* value)
{
#line 12 "../src/DragAndDropHandler.vala"
	if (value->data[0].v_pointer) {
#line 12 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (value->data[0].v_pointer);
#line 1482 "DragAndDropHandler.c"
	}
}

static void
value_drag_and_drop_handler_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 12 "../src/DragAndDropHandler.vala"
	if (src_value->data[0].v_pointer) {
#line 12 "../src/DragAndDropHandler.vala"
		dest_value->data[0].v_pointer = drag_and_drop_handler_ref (src_value->data[0].v_pointer);
#line 1494 "DragAndDropHandler.c"
	} else {
#line 12 "../src/DragAndDropHandler.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1498 "DragAndDropHandler.c"
	}
}

static gpointer
value_drag_and_drop_handler_peek_pointer (const GValue* value)
{
#line 12 "../src/DragAndDropHandler.vala"
	return value->data[0].v_pointer;
#line 1507 "DragAndDropHandler.c"
}

static gchar*
value_drag_and_drop_handler_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 12 "../src/DragAndDropHandler.vala"
	if (collect_values[0].v_pointer) {
#line 1518 "DragAndDropHandler.c"
		DragAndDropHandler * object;
		object = collect_values[0].v_pointer;
#line 12 "../src/DragAndDropHandler.vala"
		if (object->parent_instance.g_class == NULL) {
#line 12 "../src/DragAndDropHandler.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1525 "DragAndDropHandler.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 12 "../src/DragAndDropHandler.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1529 "DragAndDropHandler.c"
		}
#line 12 "../src/DragAndDropHandler.vala"
		value->data[0].v_pointer = drag_and_drop_handler_ref (object);
#line 1533 "DragAndDropHandler.c"
	} else {
#line 12 "../src/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1537 "DragAndDropHandler.c"
	}
#line 12 "../src/DragAndDropHandler.vala"
	return NULL;
#line 1541 "DragAndDropHandler.c"
}

static gchar*
value_drag_and_drop_handler_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	DragAndDropHandler ** object_p;
	object_p = collect_values[0].v_pointer;
#line 12 "../src/DragAndDropHandler.vala"
	if (!object_p) {
#line 12 "../src/DragAndDropHandler.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1556 "DragAndDropHandler.c"
	}
#line 12 "../src/DragAndDropHandler.vala"
	if (!value->data[0].v_pointer) {
#line 12 "../src/DragAndDropHandler.vala"
		*object_p = NULL;
#line 1562 "DragAndDropHandler.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 12 "../src/DragAndDropHandler.vala"
		*object_p = value->data[0].v_pointer;
#line 1566 "DragAndDropHandler.c"
	} else {
#line 12 "../src/DragAndDropHandler.vala"
		*object_p = drag_and_drop_handler_ref (value->data[0].v_pointer);
#line 1570 "DragAndDropHandler.c"
	}
#line 12 "../src/DragAndDropHandler.vala"
	return NULL;
#line 1574 "DragAndDropHandler.c"
}

GParamSpec*
param_spec_drag_and_drop_handler (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	ParamSpecDragAndDropHandler* spec;
#line 12 "../src/DragAndDropHandler.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DRAG_AND_DROP_HANDLER), NULL);
#line 12 "../src/DragAndDropHandler.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 12 "../src/DragAndDropHandler.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 12 "../src/DragAndDropHandler.vala"
	return G_PARAM_SPEC (spec);
#line 1593 "DragAndDropHandler.c"
}

gpointer
value_get_drag_and_drop_handler (const GValue* value)
{
#line 12 "../src/DragAndDropHandler.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER), NULL);
#line 12 "../src/DragAndDropHandler.vala"
	return value->data[0].v_pointer;
#line 1603 "DragAndDropHandler.c"
}

void
value_set_drag_and_drop_handler (GValue* value,
                                 gpointer v_object)
{
	DragAndDropHandler * old;
#line 12 "../src/DragAndDropHandler.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER));
#line 12 "../src/DragAndDropHandler.vala"
	old = value->data[0].v_pointer;
#line 12 "../src/DragAndDropHandler.vala"
	if (v_object) {
#line 12 "../src/DragAndDropHandler.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DRAG_AND_DROP_HANDLER));
#line 12 "../src/DragAndDropHandler.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 12 "../src/DragAndDropHandler.vala"
		value->data[0].v_pointer = v_object;
#line 12 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_ref (value->data[0].v_pointer);
#line 1625 "DragAndDropHandler.c"
	} else {
#line 12 "../src/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1629 "DragAndDropHandler.c"
	}
#line 12 "../src/DragAndDropHandler.vala"
	if (old) {
#line 12 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (old);
#line 1635 "DragAndDropHandler.c"
	}
}

void
value_take_drag_and_drop_handler (GValue* value,
                                  gpointer v_object)
{
	DragAndDropHandler * old;
#line 12 "../src/DragAndDropHandler.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DRAG_AND_DROP_HANDLER));
#line 12 "../src/DragAndDropHandler.vala"
	old = value->data[0].v_pointer;
#line 12 "../src/DragAndDropHandler.vala"
	if (v_object) {
#line 12 "../src/DragAndDropHandler.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DRAG_AND_DROP_HANDLER));
#line 12 "../src/DragAndDropHandler.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 12 "../src/DragAndDropHandler.vala"
		value->data[0].v_pointer = v_object;
#line 1656 "DragAndDropHandler.c"
	} else {
#line 12 "../src/DragAndDropHandler.vala"
		value->data[0].v_pointer = NULL;
#line 1660 "DragAndDropHandler.c"
	}
#line 12 "../src/DragAndDropHandler.vala"
	if (old) {
#line 12 "../src/DragAndDropHandler.vala"
		drag_and_drop_handler_unref (old);
#line 1666 "DragAndDropHandler.c"
	}
}

static void
drag_and_drop_handler_class_init (DragAndDropHandlerClass * klass,
                                  gpointer klass_data)
{
#line 12 "../src/DragAndDropHandler.vala"
	drag_and_drop_handler_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/DragAndDropHandler.vala"
	((DragAndDropHandlerClass *) klass)->finalize = drag_and_drop_handler_finalize;
#line 12 "../src/DragAndDropHandler.vala"
	g_type_class_adjust_private_offset (klass, &DragAndDropHandler_private_offset);
#line 1680 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_instance_init (DragAndDropHandler * self,
                                     gpointer klass)
{
#line 12 "../src/DragAndDropHandler.vala"
	self->priv = drag_and_drop_handler_get_instance_private (self);
#line 29 "../src/DragAndDropHandler.vala"
	self->priv->drag_destination = NULL;
#line 30 "../src/DragAndDropHandler.vala"
	self->priv->exporter = NULL;
#line 31 "../src/DragAndDropHandler.vala"
	self->priv->action = GDK_ACTION_COPY;
#line 12 "../src/DragAndDropHandler.vala"
	self->ref_count = 1;
#line 1697 "DragAndDropHandler.c"
}

static void
drag_and_drop_handler_finalize (DragAndDropHandler * obj)
{
	DragAndDropHandler * self;
	GtkWidget* _tmp0_;
#line 12 "../src/DragAndDropHandler.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DRAG_AND_DROP_HANDLER, DragAndDropHandler);
#line 12 "../src/DragAndDropHandler.vala"
	g_signal_handlers_destroy (self);
#line 62 "../src/DragAndDropHandler.vala"
	_tmp0_ = self->priv->event_source;
#line 62 "../src/DragAndDropHandler.vala"
	if (_tmp0_ != NULL) {
#line 1713 "DragAndDropHandler.c"
		GtkWidget* _tmp1_;
		guint _tmp2_;
		GtkWidget* _tmp3_;
		guint _tmp4_;
		GtkWidget* _tmp5_;
		guint _tmp6_;
		GtkWidget* _tmp7_;
		guint _tmp8_;
#line 63 "../src/DragAndDropHandler.vala"
		_tmp1_ = self->priv->event_source;
#line 63 "../src/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-begin", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 63 "../src/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_begin_gtk_widget_drag_begin, self);
#line 64 "../src/DragAndDropHandler.vala"
		_tmp3_ = self->priv->event_source;
#line 64 "../src/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-data-get", gtk_widget_get_type (), &_tmp4_, NULL, FALSE);
#line 64 "../src/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_data_get_gtk_widget_drag_data_get, self);
#line 65 "../src/DragAndDropHandler.vala"
		_tmp5_ = self->priv->event_source;
#line 65 "../src/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-end", gtk_widget_get_type (), &_tmp6_, NULL, FALSE);
#line 65 "../src/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_end_gtk_widget_drag_end, self);
#line 66 "../src/DragAndDropHandler.vala"
		_tmp7_ = self->priv->event_source;
#line 66 "../src/DragAndDropHandler.vala"
		g_signal_parse_name ("drag-failed", gtk_widget_get_type (), &_tmp8_, NULL, FALSE);
#line 66 "../src/DragAndDropHandler.vala"
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _drag_and_drop_handler_on_drag_failed_gtk_widget_drag_failed, self);
#line 1746 "DragAndDropHandler.c"
	}
#line 69 "../src/DragAndDropHandler.vala"
	self->priv->page = NULL;
#line 70 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 70 "../src/DragAndDropHandler.vala"
	self->priv->event_source = NULL;
#line 28 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->event_source);
#line 29 "../src/DragAndDropHandler.vala"
	_g_object_unref0 (self->priv->drag_destination);
#line 30 "../src/DragAndDropHandler.vala"
	_exporter_ui_unref0 (self->priv->exporter);
#line 1760 "DragAndDropHandler.c"
}

static GType
drag_and_drop_handler_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_drag_and_drop_handler_init, value_drag_and_drop_handler_free_value, value_drag_and_drop_handler_copy_value, value_drag_and_drop_handler_peek_pointer, "p", value_drag_and_drop_handler_collect_value, "p", value_drag_and_drop_handler_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DragAndDropHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drag_and_drop_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DragAndDropHandler), 0, (GInstanceInitFunc) drag_and_drop_handler_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType drag_and_drop_handler_type_id;
	drag_and_drop_handler_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DragAndDropHandler", &g_define_type_info, &g_define_type_fundamental_info, 0);
	DragAndDropHandler_private_offset = g_type_add_instance_private (drag_and_drop_handler_type_id, sizeof (DragAndDropHandlerPrivate));
	return drag_and_drop_handler_type_id;
}

GType
drag_and_drop_handler_get_type (void)
{
	static volatile gsize drag_and_drop_handler_type_id__once = 0;
	if (g_once_init_enter (&drag_and_drop_handler_type_id__once)) {
		GType drag_and_drop_handler_type_id;
		drag_and_drop_handler_type_id = drag_and_drop_handler_get_type_once ();
		g_once_init_leave (&drag_and_drop_handler_type_id__once, drag_and_drop_handler_type_id);
	}
	return drag_and_drop_handler_type_id__once;
}

gpointer
drag_and_drop_handler_ref (gpointer instance)
{
	DragAndDropHandler * self;
	self = instance;
#line 12 "../src/DragAndDropHandler.vala"
	g_atomic_int_inc (&self->ref_count);
#line 12 "../src/DragAndDropHandler.vala"
	return instance;
#line 1796 "DragAndDropHandler.c"
}

void
drag_and_drop_handler_unref (gpointer instance)
{
	DragAndDropHandler * self;
	self = instance;
#line 12 "../src/DragAndDropHandler.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 12 "../src/DragAndDropHandler.vala"
		DRAG_AND_DROP_HANDLER_GET_CLASS (self)->finalize (self);
#line 12 "../src/DragAndDropHandler.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1810 "DragAndDropHandler.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

