/* TimedQueue.c generated by valac 0.56.17, the Vala compiler
 * generated from TimedQueue.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* TimedQueue is a specialized collection class.  It holds items in order, but rather than being*/
/* manually dequeued, they are dequeued automatically after a specified amount of time has elapsed*/
/* for that item.  As of today, it's possible the item will be dequeued a bit later than asked*/
/* for, but it will never be early.  Future implementations might tighten up the lateness.*/
/**/
/* The original design was to use a signal to notify when an item has been dequeued, but Vala has*/
/* a bug with passing an unnamed type as a signal parameter:*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=628639*/
/**/
/* The rate the items come off the queue can be spaced out.  Note that this can cause items to back*/
/* up.  As of today, TimedQueue makes no effort to combat this.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef void (*DequeuedCallback) (gconstpointer item, gpointer user_data);

#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;
typedef struct _TimedQueuePrivate TimedQueuePrivate;

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;

#define TIMED_QUEUE_TYPE_ELEMENT (timed_queue_element_get_type ())
#define TIMED_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElement))
#define TIMED_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElementClass))
#define TIMED_QUEUE_IS_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TIMED_QUEUE_TYPE_ELEMENT))
#define TIMED_QUEUE_IS_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TIMED_QUEUE_TYPE_ELEMENT))
#define TIMED_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElementClass))

typedef struct _TimedQueueElement TimedQueueElement;
typedef struct _TimedQueueElementClass TimedQueueElementClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef struct _TimedQueueElementPrivate TimedQueueElementPrivate;
#define _timed_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (timed_queue_element_unref (var), NULL)))
typedef struct _TimedQueueParamSpecElement TimedQueueParamSpecElement;
typedef struct _ParamSpecTimedQueue ParamSpecTimedQueue;
enum  {
	TIMED_QUEUE_PAUSED_SIGNAL,
	TIMED_QUEUE_NUM_SIGNALS
};
static guint timed_queue_signals[TIMED_QUEUE_NUM_SIGNALS] = {0};

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;
typedef struct _HashTimedQueuePrivate HashTimedQueuePrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TimedQueue {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TimedQueuePrivate * priv;
};

struct _TimedQueueClass {
	GTypeClass parent_class;
	void (*finalize) (TimedQueue *self);
	void (*notify_dequeued) (TimedQueue* self, gconstpointer item);
	void (*clear) (TimedQueue* self);
	gboolean (*contains) (TimedQueue* self, gconstpointer item);
	gboolean (*enqueue) (TimedQueue* self, gconstpointer item);
	gboolean (*enqueue_many) (TimedQueue* self, GeeCollection* items);
	gboolean (*remove_first) (TimedQueue* self, gconstpointer item);
	void (*paused) (TimedQueue* self, gboolean is_paused);
	gint (*get_size) (TimedQueue* self);
};

struct _TimedQueuePrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	guint hold_msec;
	DequeuedCallback callback;
	gpointer callback_target;
	GeeEqualDataFunc equal_func;
	gpointer equal_func_target;
	GDestroyNotify equal_func_target_destroy_notify;
	gint priority;
	guint timer_id;
	SortedList* queue;
	guint dequeue_spacing_msec;
	gulong last_dequeue;
	gboolean paused_state;
};

struct _TimedQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TimedQueueElementPrivate * priv;
	gpointer item;
	gulong ready;
};

struct _TimedQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (TimedQueueElement *self);
};

struct _TimedQueueElementPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
};

struct _TimedQueueParamSpecElement {
	GParamSpec parent_instance;
};

struct _ParamSpecTimedQueue {
	GParamSpec parent_instance;
};

struct _HashTimedQueue {
	TimedQueue parent_instance;
	HashTimedQueuePrivate * priv;
};

struct _HashTimedQueueClass {
	TimedQueueClass parent_class;
};

struct _HashTimedQueuePrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeHashMap* item_count;
};

static gint TimedQueue_private_offset;
static gpointer timed_queue_parent_class = NULL;
static gint TimedQueueElement_private_offset;
static gpointer timed_queue_element_parent_class = NULL;
static gint HashTimedQueue_private_offset;
static gpointer hash_timed_queue_parent_class = NULL;

VALA_EXTERN gpointer timed_queue_ref (gpointer instance);
VALA_EXTERN void timed_queue_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_timed_queue (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_timed_queue (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_timed_queue (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_timed_queue (const GValue* value);
VALA_EXTERN GType timed_queue_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TimedQueue, timed_queue_unref)
VALA_EXTERN GType sorted_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SortedList, g_object_unref)
static gpointer timed_queue_element_ref (gpointer instance);
static void timed_queue_element_unref (gpointer instance);
static GParamSpec* timed_queue_param_spec_element (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags) G_GNUC_UNUSED ;
static void timed_queue_value_set_element (GValue* value,
                                    gpointer v_object) G_GNUC_UNUSED ;
static void timed_queue_value_take_element (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED ;
static gpointer timed_queue_value_get_element (const GValue* value) G_GNUC_UNUSED ;
static GType timed_queue_element_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TimedQueueElement, timed_queue_element_unref)
VALA_EXTERN void timed_queue_notify_dequeued (TimedQueue* self,
                                  gconstpointer item);
VALA_EXTERN void timed_queue_clear (TimedQueue* self);
VALA_EXTERN gboolean timed_queue_contains (TimedQueue* self,
                               gconstpointer item);
VALA_EXTERN gboolean timed_queue_enqueue (TimedQueue* self,
                              gconstpointer item);
VALA_EXTERN gboolean timed_queue_enqueue_many (TimedQueue* self,
                                   GeeCollection* items);
VALA_EXTERN gboolean timed_queue_remove_first (TimedQueue* self,
                                   gconstpointer item);
VALA_EXTERN gint timed_queue_get_size (TimedQueue* self);
VALA_EXTERN TimedQueue* timed_queue_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             guint hold_msec,
                             DequeuedCallback callback,
                             gpointer callback_target,
                             GeeEqualDataFunc equal_func,
                             gpointer equal_func_target,
                             GDestroyNotify equal_func_target_destroy_notify,
                             gint priority);
VALA_EXTERN TimedQueue* timed_queue_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   guint hold_msec,
                                   DequeuedCallback callback,
                                   gpointer callback_target,
                                   GeeEqualDataFunc equal_func,
                                   gpointer equal_func_target,
                                   GDestroyNotify equal_func_target_destroy_notify,
                                   gint priority);
static gint64 timed_queue_element_comparator (void* a,
                                       void* b);
static gint64 _timed_queue_element_comparator_comparator (void* a,
                                                   void* b,
                                                   gpointer self);
VALA_EXTERN SortedList* sorted_list_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             Comparator cmp,
                             gpointer cmp_target);
VALA_EXTERN SortedList* sorted_list_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   Comparator cmp,
                                   gpointer cmp_target);
static guint timed_queue_get_heartbeat_timeout (TimedQueue* self);
static gboolean timed_queue_on_heartbeat (TimedQueue* self);
static gboolean _timed_queue_on_heartbeat_gsource_func (gpointer self);
VALA_EXTERN guint timed_queue_get_dequeue_spacing_msec (TimedQueue* self);
VALA_EXTERN void timed_queue_set_dequeue_spacing_msec (TimedQueue* self,
                                           guint msec);
static void timed_queue_real_notify_dequeued (TimedQueue* self,
                                       gconstpointer item);
VALA_EXTERN gboolean timed_queue_is_paused (TimedQueue* self);
VALA_EXTERN void timed_queue_pause (TimedQueue* self);
VALA_EXTERN void timed_queue_unpause (TimedQueue* self);
static void timed_queue_real_clear (TimedQueue* self);
static gboolean timed_queue_real_contains (TimedQueue* self,
                                    gconstpointer item);
static gboolean timed_queue_real_enqueue (TimedQueue* self,
                                   gconstpointer item);
static gulong timed_queue_calc_ready_time (TimedQueue* self);
static TimedQueueElement* timed_queue_element_new (GType g_type,
                                            GBoxedCopyFunc g_dup_func,
                                            GDestroyNotify g_destroy_func,
                                            gconstpointer item,
                                            gulong ready);
static TimedQueueElement* timed_queue_element_construct (GType object_type,
                                                  GType g_type,
                                                  GBoxedCopyFunc g_dup_func,
                                                  GDestroyNotify g_destroy_func,
                                                  gconstpointer item,
                                                  gulong ready);
static gboolean timed_queue_real_enqueue_many (TimedQueue* self,
                                        GeeCollection* items);
VALA_EXTERN gboolean sorted_list_add_list (SortedList* self,
                               GeeList* items);
static gboolean timed_queue_real_remove_first (TimedQueue* self,
                                        gconstpointer item);
VALA_EXTERN gulong now_ms (void);
VALA_EXTERN gpointer sorted_list_get_at (SortedList* self,
                             gint index);
VALA_EXTERN gpointer sorted_list_remove_at (SortedList* self,
                                gint index);
static void timed_queue_real_paused (TimedQueue* self,
                              gboolean is_paused);
static void timed_queue_element_finalize (TimedQueueElement * obj);
static GType timed_queue_element_get_type_once (void);
static void timed_queue_finalize (TimedQueue * obj);
static GType timed_queue_get_type_once (void);
VALA_EXTERN GType hash_timed_queue_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HashTimedQueue, timed_queue_unref)
VALA_EXTERN HashTimedQueue* hash_timed_queue_new (GType g_type,
                                      GBoxedCopyFunc g_dup_func,
                                      GDestroyNotify g_destroy_func,
                                      guint hold_msec,
                                      DequeuedCallback callback,
                                      gpointer callback_target,
                                      GeeHashDataFunc hash_func,
                                      gpointer hash_func_target,
                                      GDestroyNotify hash_func_target_destroy_notify,
                                      GeeEqualDataFunc equal_func,
                                      gpointer equal_func_target,
                                      GDestroyNotify equal_func_target_destroy_notify,
                                      gint priority);
VALA_EXTERN HashTimedQueue* hash_timed_queue_construct (GType object_type,
                                            GType g_type,
                                            GBoxedCopyFunc g_dup_func,
                                            GDestroyNotify g_destroy_func,
                                            guint hold_msec,
                                            DequeuedCallback callback,
                                            gpointer callback_target,
                                            GeeHashDataFunc hash_func,
                                            gpointer hash_func_target,
                                            GDestroyNotify hash_func_target_destroy_notify,
                                            GeeEqualDataFunc equal_func,
                                            gpointer equal_func_target,
                                            GDestroyNotify equal_func_target_destroy_notify,
                                            gint priority);
static void hash_timed_queue_real_notify_dequeued (TimedQueue* base,
                                            gconstpointer item);
static void hash_timed_queue_removed (HashTimedQueue* self,
                               gconstpointer item);
static void hash_timed_queue_real_clear (TimedQueue* base);
static gboolean hash_timed_queue_real_contains (TimedQueue* base,
                                         gconstpointer item);
static gboolean hash_timed_queue_real_enqueue (TimedQueue* base,
                                        gconstpointer item);
static gboolean hash_timed_queue_real_enqueue_many (TimedQueue* base,
                                             GeeCollection* items);
static gboolean hash_timed_queue_real_remove_first (TimedQueue* base,
                                             gconstpointer item);
static void hash_timed_queue_finalize (TimedQueue * obj);
static GType hash_timed_queue_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
timed_queue_get_instance_private (TimedQueue* self)
{
	return G_STRUCT_MEMBER_P (self, TimedQueue_private_offset);
}

static gint64
_timed_queue_element_comparator_comparator (void* a,
                                            void* b,
                                            gpointer self)
{
	gint64 result;
	result = timed_queue_element_comparator (a, b);
#line 64 "../src/TimedQueue.vala"
	return result;
#line 378 "TimedQueue.c"
}

static gboolean
_timed_queue_on_heartbeat_gsource_func (gpointer self)
{
	gboolean result;
	result = timed_queue_on_heartbeat ((TimedQueue*) self);
#line 66 "../src/TimedQueue.vala"
	return result;
#line 388 "TimedQueue.c"
}

TimedQueue*
timed_queue_construct (GType object_type,
                       GType g_type,
                       GBoxedCopyFunc g_dup_func,
                       GDestroyNotify g_destroy_func,
                       guint hold_msec,
                       DequeuedCallback callback,
                       gpointer callback_target,
                       GeeEqualDataFunc equal_func,
                       gpointer equal_func_target,
                       GDestroyNotify equal_func_target_destroy_notify,
                       gint priority)
{
	TimedQueue* self = NULL;
	SortedList* _tmp4_;
#line 52 "../src/TimedQueue.vala"
	self = (TimedQueue*) g_type_create_instance (object_type);
#line 52 "../src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 52 "../src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 52 "../src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 54 "../src/TimedQueue.vala"
	self->priv->hold_msec = hold_msec;
#line 55 "../src/TimedQueue.vala"
	self->priv->callback = callback;
#line 55 "../src/TimedQueue.vala"
	self->priv->callback_target = callback_target;
#line 57 "../src/TimedQueue.vala"
	if (equal_func != NULL) {
#line 422 "TimedQueue.c"
		GeeEqualDataFunc _tmp0_;
		gpointer _tmp0__target;
		GDestroyNotify _tmp0__target_destroy_notify;
#line 58 "../src/TimedQueue.vala"
		_tmp0_ = equal_func;
#line 58 "../src/TimedQueue.vala"
		_tmp0__target = equal_func_target;
#line 58 "../src/TimedQueue.vala"
		_tmp0__target_destroy_notify = equal_func_target_destroy_notify;
#line 58 "../src/TimedQueue.vala"
		equal_func = NULL;
#line 58 "../src/TimedQueue.vala"
		equal_func_target = NULL;
#line 58 "../src/TimedQueue.vala"
		equal_func_target_destroy_notify = NULL;
#line 58 "../src/TimedQueue.vala"
		(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 58 "../src/TimedQueue.vala"
		self->priv->equal_func = NULL;
#line 58 "../src/TimedQueue.vala"
		self->priv->equal_func_target = NULL;
#line 58 "../src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = NULL;
#line 58 "../src/TimedQueue.vala"
		self->priv->equal_func = _tmp0_;
#line 58 "../src/TimedQueue.vala"
		self->priv->equal_func_target = _tmp0__target;
#line 58 "../src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = _tmp0__target_destroy_notify;
#line 452 "TimedQueue.c"
	} else {
		gpointer _tmp1_ = NULL;
		GDestroyNotify _tmp2_ = NULL;
		GeeEqualDataFunc _tmp3_;
#line 60 "../src/TimedQueue.vala"
		_tmp3_ = gee_functions_get_equal_func_for (g_type, &_tmp1_, &_tmp2_);
#line 60 "../src/TimedQueue.vala"
		(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func = NULL;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func_target = NULL;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = NULL;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func = (GeeEqualDataFunc) _tmp3_;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func_target = _tmp1_;
#line 60 "../src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = _tmp2_;
#line 473 "TimedQueue.c"
	}
#line 62 "../src/TimedQueue.vala"
	self->priv->priority = priority;
#line 64 "../src/TimedQueue.vala"
	_tmp4_ = sorted_list_new (TIMED_QUEUE_TYPE_ELEMENT, (GBoxedCopyFunc) timed_queue_element_ref, (GDestroyNotify) timed_queue_element_unref, _timed_queue_element_comparator_comparator, NULL);
#line 64 "../src/TimedQueue.vala"
	_g_object_unref0 (self->priv->queue);
#line 64 "../src/TimedQueue.vala"
	self->priv->queue = _tmp4_;
#line 66 "../src/TimedQueue.vala"
	self->priv->timer_id = g_timeout_add_full (priority, timed_queue_get_heartbeat_timeout (self), _timed_queue_on_heartbeat_gsource_func, timed_queue_ref (self), timed_queue_unref);
#line 52 "../src/TimedQueue.vala"
	(equal_func_target_destroy_notify == NULL) ? NULL : (equal_func_target_destroy_notify (equal_func_target), NULL);
#line 52 "../src/TimedQueue.vala"
	equal_func = NULL;
#line 52 "../src/TimedQueue.vala"
	equal_func_target = NULL;
#line 52 "../src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 52 "../src/TimedQueue.vala"
	return self;
#line 495 "TimedQueue.c"
}

TimedQueue*
timed_queue_new (GType g_type,
                 GBoxedCopyFunc g_dup_func,
                 GDestroyNotify g_destroy_func,
                 guint hold_msec,
                 DequeuedCallback callback,
                 gpointer callback_target,
                 GeeEqualDataFunc equal_func,
                 gpointer equal_func_target,
                 GDestroyNotify equal_func_target_destroy_notify,
                 gint priority)
{
#line 52 "../src/TimedQueue.vala"
	return timed_queue_construct (TYPE_TIMED_QUEUE, g_type, g_dup_func, g_destroy_func, hold_msec, callback, callback_target, equal_func, equal_func_target, equal_func_target_destroy_notify, priority);
#line 512 "TimedQueue.c"
}

guint
timed_queue_get_dequeue_spacing_msec (TimedQueue* self)
{
	guint result;
#line 74 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), 0U);
#line 75 "../src/TimedQueue.vala"
	result = self->priv->dequeue_spacing_msec;
#line 75 "../src/TimedQueue.vala"
	return result;
#line 525 "TimedQueue.c"
}

void
timed_queue_set_dequeue_spacing_msec (TimedQueue* self,
                                      guint msec)
{
#line 78 "../src/TimedQueue.vala"
	g_return_if_fail (IS_TIMED_QUEUE (self));
#line 79 "../src/TimedQueue.vala"
	if (msec == self->priv->dequeue_spacing_msec) {
#line 80 "../src/TimedQueue.vala"
		return;
#line 538 "TimedQueue.c"
	}
#line 82 "../src/TimedQueue.vala"
	if (self->priv->timer_id != ((guint) 0)) {
#line 83 "../src/TimedQueue.vala"
		g_source_remove (self->priv->timer_id);
#line 544 "TimedQueue.c"
	}
#line 85 "../src/TimedQueue.vala"
	self->priv->dequeue_spacing_msec = msec;
#line 87 "../src/TimedQueue.vala"
	self->priv->timer_id = g_timeout_add_full (self->priv->priority, timed_queue_get_heartbeat_timeout (self), _timed_queue_on_heartbeat_gsource_func, timed_queue_ref (self), timed_queue_unref);
#line 550 "TimedQueue.c"
}

static guint
timed_queue_get_heartbeat_timeout (TimedQueue* self)
{
	guint _tmp0_ = 0U;
	guint result;
#line 90 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), 0U);
#line 91 "../src/TimedQueue.vala"
	if (self->priv->dequeue_spacing_msec == ((guint) 0)) {
#line 92 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->hold_msec / 10;
#line 564 "TimedQueue.c"
	} else {
#line 93 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->dequeue_spacing_msec / 2;
#line 568 "TimedQueue.c"
	}
#line 91 "../src/TimedQueue.vala"
	result = CLAMP (_tmp0_, (guint) 10, G_MAXUINT);
#line 91 "../src/TimedQueue.vala"
	return result;
#line 574 "TimedQueue.c"
}

static void
timed_queue_real_notify_dequeued (TimedQueue* self,
                                  gconstpointer item)
{
	DequeuedCallback _tmp0_;
	gpointer _tmp0__target;
#line 97 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->callback;
#line 97 "../src/TimedQueue.vala"
	_tmp0__target = self->priv->callback_target;
#line 97 "../src/TimedQueue.vala"
	_tmp0_ (item, _tmp0__target);
#line 589 "TimedQueue.c"
}

void
timed_queue_notify_dequeued (TimedQueue* self,
                             gconstpointer item)
{
	TimedQueueClass* _klass_;
#line 96 "../src/TimedQueue.vala"
	g_return_if_fail (IS_TIMED_QUEUE (self));
#line 96 "../src/TimedQueue.vala"
	_klass_ = TIMED_QUEUE_GET_CLASS (self);
#line 96 "../src/TimedQueue.vala"
	if (_klass_->notify_dequeued) {
#line 96 "../src/TimedQueue.vala"
		_klass_->notify_dequeued (self, item);
#line 605 "TimedQueue.c"
	}
}

gboolean
timed_queue_is_paused (TimedQueue* self)
{
	gboolean result;
#line 100 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), FALSE);
#line 101 "../src/TimedQueue.vala"
	result = self->priv->paused_state;
#line 101 "../src/TimedQueue.vala"
	return result;
#line 619 "TimedQueue.c"
}

void
timed_queue_pause (TimedQueue* self)
{
#line 104 "../src/TimedQueue.vala"
	g_return_if_fail (IS_TIMED_QUEUE (self));
#line 105 "../src/TimedQueue.vala"
	if (self->priv->paused_state) {
#line 106 "../src/TimedQueue.vala"
		return;
#line 631 "TimedQueue.c"
	}
#line 108 "../src/TimedQueue.vala"
	self->priv->paused_state = TRUE;
#line 110 "../src/TimedQueue.vala"
	g_signal_emit (self, timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL], 0, TRUE);
#line 637 "TimedQueue.c"
}

void
timed_queue_unpause (TimedQueue* self)
{
#line 113 "../src/TimedQueue.vala"
	g_return_if_fail (IS_TIMED_QUEUE (self));
#line 114 "../src/TimedQueue.vala"
	if (!self->priv->paused_state) {
#line 115 "../src/TimedQueue.vala"
		return;
#line 649 "TimedQueue.c"
	}
#line 117 "../src/TimedQueue.vala"
	self->priv->paused_state = FALSE;
#line 119 "../src/TimedQueue.vala"
	g_signal_emit (self, timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL], 0, FALSE);
#line 655 "TimedQueue.c"
}

static void
timed_queue_real_clear (TimedQueue* self)
{
	SortedList* _tmp0_;
#line 123 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 123 "../src/TimedQueue.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 666 "TimedQueue.c"
}

void
timed_queue_clear (TimedQueue* self)
{
	TimedQueueClass* _klass_;
#line 122 "../src/TimedQueue.vala"
	g_return_if_fail (IS_TIMED_QUEUE (self));
#line 122 "../src/TimedQueue.vala"
	_klass_ = TIMED_QUEUE_GET_CLASS (self);
#line 122 "../src/TimedQueue.vala"
	if (_klass_->clear) {
#line 122 "../src/TimedQueue.vala"
		_klass_->clear (self);
#line 681 "TimedQueue.c"
	}
}

static gboolean
timed_queue_real_contains (TimedQueue* self,
                           gconstpointer item)
{
	gboolean result;
	{
		GeeIterator* _e_it = NULL;
		SortedList* _tmp0_;
		GeeIterator* _tmp1_;
#line 127 "../src/TimedQueue.vala"
		_tmp0_ = self->priv->queue;
#line 127 "../src/TimedQueue.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 127 "../src/TimedQueue.vala"
		_e_it = _tmp1_;
#line 127 "../src/TimedQueue.vala"
		while (TRUE) {
#line 702 "TimedQueue.c"
			GeeIterator* _tmp2_;
			TimedQueueElement* e = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeEqualDataFunc _tmp5_;
			gpointer _tmp5__target;
			TimedQueueElement* _tmp6_;
			gconstpointer _tmp7_;
#line 127 "../src/TimedQueue.vala"
			_tmp2_ = _e_it;
#line 127 "../src/TimedQueue.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 127 "../src/TimedQueue.vala"
				break;
#line 717 "TimedQueue.c"
			}
#line 127 "../src/TimedQueue.vala"
			_tmp3_ = _e_it;
#line 127 "../src/TimedQueue.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 127 "../src/TimedQueue.vala"
			e = (TimedQueueElement*) _tmp4_;
#line 128 "../src/TimedQueue.vala"
			_tmp5_ = self->priv->equal_func;
#line 128 "../src/TimedQueue.vala"
			_tmp5__target = self->priv->equal_func_target;
#line 128 "../src/TimedQueue.vala"
			_tmp6_ = e;
#line 128 "../src/TimedQueue.vala"
			_tmp7_ = _tmp6_->item;
#line 128 "../src/TimedQueue.vala"
			if (_tmp5_ (item, _tmp7_, _tmp5__target)) {
#line 129 "../src/TimedQueue.vala"
				result = TRUE;
#line 129 "../src/TimedQueue.vala"
				_timed_queue_element_unref0 (e);
#line 129 "../src/TimedQueue.vala"
				_g_object_unref0 (_e_it);
#line 129 "../src/TimedQueue.vala"
				return result;
#line 743 "TimedQueue.c"
			}
#line 127 "../src/TimedQueue.vala"
			_timed_queue_element_unref0 (e);
#line 747 "TimedQueue.c"
		}
#line 127 "../src/TimedQueue.vala"
		_g_object_unref0 (_e_it);
#line 751 "TimedQueue.c"
	}
#line 132 "../src/TimedQueue.vala"
	result = FALSE;
#line 132 "../src/TimedQueue.vala"
	return result;
#line 757 "TimedQueue.c"
}

gboolean
timed_queue_contains (TimedQueue* self,
                      gconstpointer item)
{
	TimedQueueClass* _klass_;
#line 126 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), FALSE);
#line 126 "../src/TimedQueue.vala"
	_klass_ = TIMED_QUEUE_GET_CLASS (self);
#line 126 "../src/TimedQueue.vala"
	if (_klass_->contains) {
#line 126 "../src/TimedQueue.vala"
		return _klass_->contains (self, item);
#line 773 "TimedQueue.c"
	}
#line 126 "../src/TimedQueue.vala"
	return FALSE;
#line 777 "TimedQueue.c"
}

static gboolean
timed_queue_real_enqueue (TimedQueue* self,
                          gconstpointer item)
{
	SortedList* _tmp0_;
	TimedQueueElement* _tmp1_;
	TimedQueueElement* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 136 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 136 "../src/TimedQueue.vala"
	_tmp1_ = timed_queue_element_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, item, timed_queue_calc_ready_time (self));
#line 136 "../src/TimedQueue.vala"
	_tmp2_ = _tmp1_;
#line 136 "../src/TimedQueue.vala"
	_tmp3_ = gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _tmp2_);
#line 136 "../src/TimedQueue.vala"
	_timed_queue_element_unref0 (_tmp2_);
#line 136 "../src/TimedQueue.vala"
	result = _tmp3_;
#line 136 "../src/TimedQueue.vala"
	return result;
#line 803 "TimedQueue.c"
}

gboolean
timed_queue_enqueue (TimedQueue* self,
                     gconstpointer item)
{
	TimedQueueClass* _klass_;
#line 135 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), FALSE);
#line 135 "../src/TimedQueue.vala"
	_klass_ = TIMED_QUEUE_GET_CLASS (self);
#line 135 "../src/TimedQueue.vala"
	if (_klass_->enqueue) {
#line 135 "../src/TimedQueue.vala"
		return _klass_->enqueue (self, item);
#line 819 "TimedQueue.c"
	}
#line 135 "../src/TimedQueue.vala"
	return FALSE;
#line 823 "TimedQueue.c"
}

static gboolean
timed_queue_real_enqueue_many (TimedQueue* self,
                               GeeCollection* items)
{
	gulong ready_time = 0UL;
	GeeArrayList* elements = NULL;
	GeeArrayList* _tmp0_;
	SortedList* _tmp9_;
	GeeArrayList* _tmp10_;
	gboolean result;
#line 139 "../src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (items, GEE_TYPE_COLLECTION), FALSE);
#line 140 "../src/TimedQueue.vala"
	ready_time = timed_queue_calc_ready_time (self);
#line 142 "../src/TimedQueue.vala"
	_tmp0_ = gee_array_list_new (TIMED_QUEUE_TYPE_ELEMENT, (GBoxedCopyFunc) timed_queue_element_ref, (GDestroyNotify) timed_queue_element_unref, NULL, NULL, NULL);
#line 142 "../src/TimedQueue.vala"
	elements = _tmp0_;
#line 844 "TimedQueue.c"
	{
		GeeIterator* _item_it = NULL;
		GeeIterator* _tmp1_;
#line 143 "../src/TimedQueue.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (items, GEE_TYPE_ITERABLE, GeeIterable));
#line 143 "../src/TimedQueue.vala"
		_item_it = _tmp1_;
#line 143 "../src/TimedQueue.vala"
		while (TRUE) {
#line 854 "TimedQueue.c"
			GeeIterator* _tmp2_;
			gpointer item = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			gconstpointer _tmp6_;
			TimedQueueElement* _tmp7_;
			TimedQueueElement* _tmp8_;
#line 143 "../src/TimedQueue.vala"
			_tmp2_ = _item_it;
#line 143 "../src/TimedQueue.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 143 "../src/TimedQueue.vala"
				break;
#line 869 "TimedQueue.c"
			}
#line 143 "../src/TimedQueue.vala"
			_tmp3_ = _item_it;
#line 143 "../src/TimedQueue.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 143 "../src/TimedQueue.vala"
			item = _tmp4_;
#line 144 "../src/TimedQueue.vala"
			_tmp5_ = elements;
#line 144 "../src/TimedQueue.vala"
			_tmp6_ = item;
#line 144 "../src/TimedQueue.vala"
			_tmp7_ = timed_queue_element_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, _tmp6_, ready_time);
#line 144 "../src/TimedQueue.vala"
			_tmp8_ = _tmp7_;
#line 144 "../src/TimedQueue.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp8_);
#line 144 "../src/TimedQueue.vala"
			_timed_queue_element_unref0 (_tmp8_);
#line 143 "../src/TimedQueue.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 891 "TimedQueue.c"
		}
#line 143 "../src/TimedQueue.vala"
		_g_object_unref0 (_item_it);
#line 895 "TimedQueue.c"
	}
#line 146 "../src/TimedQueue.vala"
	_tmp9_ = self->priv->queue;
#line 146 "../src/TimedQueue.vala"
	_tmp10_ = elements;
#line 146 "../src/TimedQueue.vala"
	result = sorted_list_add_list (_tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_LIST, GeeList));
#line 146 "../src/TimedQueue.vala"
	_g_object_unref0 (elements);
#line 146 "../src/TimedQueue.vala"
	return result;
#line 907 "TimedQueue.c"
}

gboolean
timed_queue_enqueue_many (TimedQueue* self,
                          GeeCollection* items)
{
	TimedQueueClass* _klass_;
#line 139 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), FALSE);
#line 139 "../src/TimedQueue.vala"
	_klass_ = TIMED_QUEUE_GET_CLASS (self);
#line 139 "../src/TimedQueue.vala"
	if (_klass_->enqueue_many) {
#line 139 "../src/TimedQueue.vala"
		return _klass_->enqueue_many (self, items);
#line 923 "TimedQueue.c"
	}
#line 139 "../src/TimedQueue.vala"
	return FALSE;
#line 927 "TimedQueue.c"
}

static gboolean
timed_queue_real_remove_first (TimedQueue* self,
                               gconstpointer item)
{
	GeeIterator* iter = NULL;
	SortedList* _tmp0_;
	GeeIterator* _tmp1_;
	gboolean result;
#line 150 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 150 "../src/TimedQueue.vala"
	_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 150 "../src/TimedQueue.vala"
	iter = _tmp1_;
#line 151 "../src/TimedQueue.vala"
	while (TRUE) {
#line 946 "TimedQueue.c"
		GeeIterator* _tmp2_;
		TimedQueueElement* e = NULL;
		GeeIterator* _tmp3_;
		gpointer _tmp4_;
		GeeEqualDataFunc _tmp5_;
		gpointer _tmp5__target;
		TimedQueueElement* _tmp6_;
		gconstpointer _tmp7_;
#line 151 "../src/TimedQueue.vala"
		_tmp2_ = iter;
#line 151 "../src/TimedQueue.vala"
		if (!gee_iterator_next (_tmp2_)) {
#line 151 "../src/TimedQueue.vala"
			break;
#line 961 "TimedQueue.c"
		}
#line 152 "../src/TimedQueue.vala"
		_tmp3_ = iter;
#line 152 "../src/TimedQueue.vala"
		_tmp4_ = gee_iterator_get (_tmp3_);
#line 152 "../src/TimedQueue.vala"
		e = (TimedQueueElement*) _tmp4_;
#line 153 "../src/TimedQueue.vala"
		_tmp5_ = self->priv->equal_func;
#line 153 "../src/TimedQueue.vala"
		_tmp5__target = self->priv->equal_func_target;
#line 153 "../src/TimedQueue.vala"
		_tmp6_ = e;
#line 153 "../src/TimedQueue.vala"
		_tmp7_ = _tmp6_->item;
#line 153 "../src/TimedQueue.vala"
		if (_tmp5_ (item, _tmp7_, _tmp5__target)) {
#line 979 "TimedQueue.c"
			GeeIterator* _tmp8_;
#line 154 "../src/TimedQueue.vala"
			_tmp8_ = iter;
#line 154 "../src/TimedQueue.vala"
			gee_iterator_remove (_tmp8_);
#line 156 "../src/TimedQueue.vala"
			result = TRUE;
#line 156 "../src/TimedQueue.vala"
			_timed_queue_element_unref0 (e);
#line 156 "../src/TimedQueue.vala"
			_g_object_unref0 (iter);
#line 156 "../src/TimedQueue.vala"
			return result;
#line 993 "TimedQueue.c"
		}
#line 151 "../src/TimedQueue.vala"
		_timed_queue_element_unref0 (e);
#line 997 "TimedQueue.c"
	}
#line 160 "../src/TimedQueue.vala"
	result = FALSE;
#line 160 "../src/TimedQueue.vala"
	_g_object_unref0 (iter);
#line 160 "../src/TimedQueue.vala"
	return result;
#line 1005 "TimedQueue.c"
}

gboolean
timed_queue_remove_first (TimedQueue* self,
                          gconstpointer item)
{
	TimedQueueClass* _klass_;
#line 149 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), FALSE);
#line 149 "../src/TimedQueue.vala"
	_klass_ = TIMED_QUEUE_GET_CLASS (self);
#line 149 "../src/TimedQueue.vala"
	if (_klass_->remove_first) {
#line 149 "../src/TimedQueue.vala"
		return _klass_->remove_first (self, item);
#line 1021 "TimedQueue.c"
	}
#line 149 "../src/TimedQueue.vala"
	return FALSE;
#line 1025 "TimedQueue.c"
}

static gulong
timed_queue_calc_ready_time (TimedQueue* self)
{
	gulong result;
#line 169 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), 0UL);
#line 170 "../src/TimedQueue.vala"
	result = now_ms () + ((gulong) self->priv->hold_msec);
#line 170 "../src/TimedQueue.vala"
	return result;
#line 1038 "TimedQueue.c"
}

static gboolean
timed_queue_on_heartbeat (TimedQueue* self)
{
	gulong now = 0UL;
	gboolean result;
#line 173 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), FALSE);
#line 174 "../src/TimedQueue.vala"
	if (self->priv->paused_state) {
#line 175 "../src/TimedQueue.vala"
		result = TRUE;
#line 175 "../src/TimedQueue.vala"
		return result;
#line 1054 "TimedQueue.c"
	}
#line 177 "../src/TimedQueue.vala"
	now = (gulong) 0;
#line 1058 "TimedQueue.c"
	{
		gboolean _tmp0_ = FALSE;
#line 179 "../src/TimedQueue.vala"
		_tmp0_ = TRUE;
#line 179 "../src/TimedQueue.vala"
		while (TRUE) {
#line 1065 "TimedQueue.c"
			SortedList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
			TimedQueueElement* head = NULL;
			SortedList* _tmp4_;
			gpointer _tmp5_;
			TimedQueueElement* _tmp6_;
			TimedQueueElement* _tmp7_;
			gboolean _tmp8_ = FALSE;
			TimedQueueElement* h = NULL;
			SortedList* _tmp9_;
			gpointer _tmp10_;
			TimedQueueElement* _tmp11_;
			TimedQueueElement* _tmp12_;
			TimedQueueElement* _tmp13_;
			gconstpointer _tmp14_;
#line 179 "../src/TimedQueue.vala"
			if (!_tmp0_) {
#line 1084 "TimedQueue.c"
			}
#line 179 "../src/TimedQueue.vala"
			_tmp0_ = FALSE;
#line 180 "../src/TimedQueue.vala"
			_tmp1_ = self->priv->queue;
#line 180 "../src/TimedQueue.vala"
			_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 180 "../src/TimedQueue.vala"
			_tmp3_ = _tmp2_;
#line 180 "../src/TimedQueue.vala"
			if (_tmp3_ == 0) {
#line 181 "../src/TimedQueue.vala"
				break;
#line 1098 "TimedQueue.c"
			}
#line 183 "../src/TimedQueue.vala"
			_tmp4_ = self->priv->queue;
#line 183 "../src/TimedQueue.vala"
			_tmp5_ = sorted_list_get_at (_tmp4_, 0);
#line 183 "../src/TimedQueue.vala"
			head = (TimedQueueElement*) _tmp5_;
#line 184 "../src/TimedQueue.vala"
			_tmp6_ = head;
#line 184 "../src/TimedQueue.vala"
			_vala_assert (_tmp6_ != NULL, "head != null");
#line 186 "../src/TimedQueue.vala"
			if (now == ((gulong) 0)) {
#line 187 "../src/TimedQueue.vala"
				now = now_ms ();
#line 1114 "TimedQueue.c"
			}
#line 189 "../src/TimedQueue.vala"
			_tmp7_ = head;
#line 189 "../src/TimedQueue.vala"
			if (_tmp7_->ready > now) {
#line 190 "../src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 190 "../src/TimedQueue.vala"
				break;
#line 1124 "TimedQueue.c"
			}
#line 193 "../src/TimedQueue.vala"
			if (self->priv->dequeue_spacing_msec != ((guint) 0)) {
#line 193 "../src/TimedQueue.vala"
				_tmp8_ = (now - self->priv->last_dequeue) < ((gulong) self->priv->dequeue_spacing_msec);
#line 1130 "TimedQueue.c"
			} else {
#line 193 "../src/TimedQueue.vala"
				_tmp8_ = FALSE;
#line 1134 "TimedQueue.c"
			}
#line 193 "../src/TimedQueue.vala"
			if (_tmp8_) {
#line 194 "../src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 194 "../src/TimedQueue.vala"
				break;
#line 1142 "TimedQueue.c"
			}
#line 196 "../src/TimedQueue.vala"
			_tmp9_ = self->priv->queue;
#line 196 "../src/TimedQueue.vala"
			_tmp10_ = sorted_list_remove_at (_tmp9_, 0);
#line 196 "../src/TimedQueue.vala"
			h = (TimedQueueElement*) _tmp10_;
#line 197 "../src/TimedQueue.vala"
			_tmp11_ = head;
#line 197 "../src/TimedQueue.vala"
			_tmp12_ = h;
#line 197 "../src/TimedQueue.vala"
			_vala_assert (_tmp11_ == _tmp12_, "head == h");
#line 199 "../src/TimedQueue.vala"
			_tmp13_ = head;
#line 199 "../src/TimedQueue.vala"
			_tmp14_ = _tmp13_->item;
#line 199 "../src/TimedQueue.vala"
			timed_queue_notify_dequeued (self, _tmp14_);
#line 200 "../src/TimedQueue.vala"
			self->priv->last_dequeue = now;
#line 204 "../src/TimedQueue.vala"
			if (self->priv->dequeue_spacing_msec != ((guint) 0)) {
#line 205 "../src/TimedQueue.vala"
				_timed_queue_element_unref0 (h);
#line 205 "../src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 205 "../src/TimedQueue.vala"
				break;
#line 1172 "TimedQueue.c"
			}
#line 179 "../src/TimedQueue.vala"
			_timed_queue_element_unref0 (h);
#line 179 "../src/TimedQueue.vala"
			_timed_queue_element_unref0 (head);
#line 1178 "TimedQueue.c"
		}
	}
#line 208 "../src/TimedQueue.vala"
	result = TRUE;
#line 208 "../src/TimedQueue.vala"
	return result;
#line 1185 "TimedQueue.c"
}

gint
timed_queue_get_size (TimedQueue* self)
{
	TimedQueueClass* _klass_;
#line 164 "../src/TimedQueue.vala"
	g_return_val_if_fail (IS_TIMED_QUEUE (self), 0);
#line 164 "../src/TimedQueue.vala"
	_klass_ = TIMED_QUEUE_GET_CLASS (self);
#line 164 "../src/TimedQueue.vala"
	if (_klass_->get_size) {
#line 164 "../src/TimedQueue.vala"
		return _klass_->get_size (self);
#line 1200 "TimedQueue.c"
	}
#line 164 "../src/TimedQueue.vala"
	return -1;
#line 1204 "TimedQueue.c"
}

static gint
timed_queue_real_get_size (TimedQueue* base)
{
	gint result;
	TimedQueue* self;
	SortedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 164 "../src/TimedQueue.vala"
	self = base;
#line 165 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 165 "../src/TimedQueue.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 165 "../src/TimedQueue.vala"
	_tmp2_ = _tmp1_;
#line 165 "../src/TimedQueue.vala"
	result = _tmp2_;
#line 165 "../src/TimedQueue.vala"
	return result;
#line 1227 "TimedQueue.c"
}

static void
timed_queue_real_paused (TimedQueue* self,
                         gboolean is_paused)
{
}

static inline gpointer
timed_queue_element_get_instance_private (TimedQueueElement* self)
{
	return G_STRUCT_MEMBER_P (self, TimedQueueElement_private_offset);
}

static TimedQueueElement*
timed_queue_element_construct (GType object_type,
                               GType g_type,
                               GBoxedCopyFunc g_dup_func,
                               GDestroyNotify g_destroy_func,
                               gconstpointer item,
                               gulong ready)
{
	TimedQueueElement* self = NULL;
	gpointer _tmp0_;
#line 26 "../src/TimedQueue.vala"
	self = (TimedQueueElement*) g_type_create_instance (object_type);
#line 26 "../src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 26 "../src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 26 "../src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 27 "../src/TimedQueue.vala"
	_tmp0_ = ((item != NULL) && (g_dup_func != NULL)) ? g_dup_func ((gpointer) item) : ((gpointer) item);
#line 27 "../src/TimedQueue.vala"
	((self->item == NULL) || (g_destroy_func == NULL)) ? NULL : (self->item = (g_destroy_func (self->item), NULL));
#line 27 "../src/TimedQueue.vala"
	self->item = _tmp0_;
#line 28 "../src/TimedQueue.vala"
	self->ready = ready;
#line 26 "../src/TimedQueue.vala"
	return self;
#line 1270 "TimedQueue.c"
}

static TimedQueueElement*
timed_queue_element_new (GType g_type,
                         GBoxedCopyFunc g_dup_func,
                         GDestroyNotify g_destroy_func,
                         gconstpointer item,
                         gulong ready)
{
#line 26 "../src/TimedQueue.vala"
	return timed_queue_element_construct (TIMED_QUEUE_TYPE_ELEMENT, g_type, g_dup_func, g_destroy_func, item, ready);
#line 1282 "TimedQueue.c"
}

static gint64
timed_queue_element_comparator (void* a,
                                void* b)
{
	gint64 result;
#line 32 "../src/TimedQueue.vala"
	result = ((gint64) G_TYPE_CHECK_INSTANCE_CAST ((TimedQueueElement*) a, TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElement)->ready) - ((gint64) G_TYPE_CHECK_INSTANCE_CAST ((TimedQueueElement*) b, TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElement)->ready);
#line 32 "../src/TimedQueue.vala"
	return result;
#line 1294 "TimedQueue.c"
}

static void
timed_queue_value_element_init (GValue* value)
{
#line 22 "../src/TimedQueue.vala"
	value->data[0].v_pointer = NULL;
#line 1302 "TimedQueue.c"
}

static void
timed_queue_value_element_free_value (GValue* value)
{
#line 22 "../src/TimedQueue.vala"
	if (value->data[0].v_pointer) {
#line 22 "../src/TimedQueue.vala"
		timed_queue_element_unref (value->data[0].v_pointer);
#line 1312 "TimedQueue.c"
	}
}

static void
timed_queue_value_element_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 22 "../src/TimedQueue.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../src/TimedQueue.vala"
		dest_value->data[0].v_pointer = timed_queue_element_ref (src_value->data[0].v_pointer);
#line 1324 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1328 "TimedQueue.c"
	}
}

static gpointer
timed_queue_value_element_peek_pointer (const GValue* value)
{
#line 22 "../src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1337 "TimedQueue.c"
}

static gchar*
timed_queue_value_element_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 22 "../src/TimedQueue.vala"
	if (collect_values[0].v_pointer) {
#line 1348 "TimedQueue.c"
		TimedQueueElement * object;
		object = collect_values[0].v_pointer;
#line 22 "../src/TimedQueue.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../src/TimedQueue.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1355 "TimedQueue.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../src/TimedQueue.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1359 "TimedQueue.c"
		}
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = timed_queue_element_ref (object);
#line 1363 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1367 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	return NULL;
#line 1371 "TimedQueue.c"
}

static gchar*
timed_queue_value_element_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	TimedQueueElement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../src/TimedQueue.vala"
	if (!object_p) {
#line 22 "../src/TimedQueue.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1386 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../src/TimedQueue.vala"
		*object_p = NULL;
#line 1392 "TimedQueue.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../src/TimedQueue.vala"
		*object_p = value->data[0].v_pointer;
#line 1396 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		*object_p = timed_queue_element_ref (value->data[0].v_pointer);
#line 1400 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	return NULL;
#line 1404 "TimedQueue.c"
}

static GParamSpec*
timed_queue_param_spec_element (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	TimedQueueParamSpecElement* spec;
#line 22 "../src/TimedQueue.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TIMED_QUEUE_TYPE_ELEMENT), NULL);
#line 22 "../src/TimedQueue.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../src/TimedQueue.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../src/TimedQueue.vala"
	return G_PARAM_SPEC (spec);
#line 1423 "TimedQueue.c"
}

static gpointer
timed_queue_value_get_element (const GValue* value)
{
#line 22 "../src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT), NULL);
#line 22 "../src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1433 "TimedQueue.c"
}

static void
timed_queue_value_set_element (GValue* value,
                               gpointer v_object)
{
	TimedQueueElement * old;
#line 22 "../src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT));
#line 22 "../src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/TimedQueue.vala"
	if (v_object) {
#line 22 "../src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TIMED_QUEUE_TYPE_ELEMENT));
#line 22 "../src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../src/TimedQueue.vala"
		timed_queue_element_ref (value->data[0].v_pointer);
#line 1455 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1459 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	if (old) {
#line 22 "../src/TimedQueue.vala"
		timed_queue_element_unref (old);
#line 1465 "TimedQueue.c"
	}
}

static void
timed_queue_value_take_element (GValue* value,
                                gpointer v_object)
{
	TimedQueueElement * old;
#line 22 "../src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT));
#line 22 "../src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/TimedQueue.vala"
	if (v_object) {
#line 22 "../src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TIMED_QUEUE_TYPE_ELEMENT));
#line 22 "../src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 1486 "TimedQueue.c"
	} else {
#line 22 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1490 "TimedQueue.c"
	}
#line 22 "../src/TimedQueue.vala"
	if (old) {
#line 22 "../src/TimedQueue.vala"
		timed_queue_element_unref (old);
#line 1496 "TimedQueue.c"
	}
}

static void
timed_queue_element_class_init (TimedQueueElementClass * klass,
                                gpointer klass_data)
{
#line 22 "../src/TimedQueue.vala"
	timed_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/TimedQueue.vala"
	((TimedQueueElementClass *) klass)->finalize = timed_queue_element_finalize;
#line 22 "../src/TimedQueue.vala"
	g_type_class_adjust_private_offset (klass, &TimedQueueElement_private_offset);
#line 1510 "TimedQueue.c"
}

static void
timed_queue_element_instance_init (TimedQueueElement * self,
                                   gpointer klass)
{
#line 22 "../src/TimedQueue.vala"
	self->priv = timed_queue_element_get_instance_private (self);
#line 22 "../src/TimedQueue.vala"
	self->ref_count = 1;
#line 1521 "TimedQueue.c"
}

static void
timed_queue_element_finalize (TimedQueueElement * obj)
{
	TimedQueueElement * self;
#line 22 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElement);
#line 22 "../src/TimedQueue.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/TimedQueue.vala"
	((self->item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->item = (self->priv->g_destroy_func (self->item), NULL));
#line 1534 "TimedQueue.c"
}

static GType
timed_queue_element_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { timed_queue_value_element_init, timed_queue_value_element_free_value, timed_queue_value_element_copy_value, timed_queue_value_element_peek_pointer, "p", timed_queue_value_element_collect_value, "p", timed_queue_value_element_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TimedQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timed_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimedQueueElement), 0, (GInstanceInitFunc) timed_queue_element_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType timed_queue_element_type_id;
	timed_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TimedQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TimedQueueElement_private_offset = g_type_add_instance_private (timed_queue_element_type_id, sizeof (TimedQueueElementPrivate));
	return timed_queue_element_type_id;
}

static GType
timed_queue_element_get_type (void)
{
	static volatile gsize timed_queue_element_type_id__once = 0;
	if (g_once_init_enter (&timed_queue_element_type_id__once)) {
		GType timed_queue_element_type_id;
		timed_queue_element_type_id = timed_queue_element_get_type_once ();
		g_once_init_leave (&timed_queue_element_type_id__once, timed_queue_element_type_id);
	}
	return timed_queue_element_type_id__once;
}

static gpointer
timed_queue_element_ref (gpointer instance)
{
	TimedQueueElement * self;
	self = instance;
#line 22 "../src/TimedQueue.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../src/TimedQueue.vala"
	return instance;
#line 1570 "TimedQueue.c"
}

static void
timed_queue_element_unref (gpointer instance)
{
	TimedQueueElement * self;
	self = instance;
#line 22 "../src/TimedQueue.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../src/TimedQueue.vala"
		TIMED_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 22 "../src/TimedQueue.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1584 "TimedQueue.c"
	}
}

static void
value_timed_queue_init (GValue* value)
{
#line 21 "../src/TimedQueue.vala"
	value->data[0].v_pointer = NULL;
#line 1593 "TimedQueue.c"
}

static void
value_timed_queue_free_value (GValue* value)
{
#line 21 "../src/TimedQueue.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/TimedQueue.vala"
		timed_queue_unref (value->data[0].v_pointer);
#line 1603 "TimedQueue.c"
	}
}

static void
value_timed_queue_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 21 "../src/TimedQueue.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/TimedQueue.vala"
		dest_value->data[0].v_pointer = timed_queue_ref (src_value->data[0].v_pointer);
#line 1615 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1619 "TimedQueue.c"
	}
}

static gpointer
value_timed_queue_peek_pointer (const GValue* value)
{
#line 21 "../src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1628 "TimedQueue.c"
}

static gchar*
value_timed_queue_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 21 "../src/TimedQueue.vala"
	if (collect_values[0].v_pointer) {
#line 1639 "TimedQueue.c"
		TimedQueue * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/TimedQueue.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/TimedQueue.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1646 "TimedQueue.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/TimedQueue.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1650 "TimedQueue.c"
		}
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = timed_queue_ref (object);
#line 1654 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1658 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	return NULL;
#line 1662 "TimedQueue.c"
}

static gchar*
value_timed_queue_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	TimedQueue ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/TimedQueue.vala"
	if (!object_p) {
#line 21 "../src/TimedQueue.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1677 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/TimedQueue.vala"
		*object_p = NULL;
#line 1683 "TimedQueue.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/TimedQueue.vala"
		*object_p = value->data[0].v_pointer;
#line 1687 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		*object_p = timed_queue_ref (value->data[0].v_pointer);
#line 1691 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	return NULL;
#line 1695 "TimedQueue.c"
}

GParamSpec*
param_spec_timed_queue (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecTimedQueue* spec;
#line 21 "../src/TimedQueue.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TIMED_QUEUE), NULL);
#line 21 "../src/TimedQueue.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/TimedQueue.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/TimedQueue.vala"
	return G_PARAM_SPEC (spec);
#line 1714 "TimedQueue.c"
}

gpointer
value_get_timed_queue (const GValue* value)
{
#line 21 "../src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE), NULL);
#line 21 "../src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1724 "TimedQueue.c"
}

void
value_set_timed_queue (GValue* value,
                       gpointer v_object)
{
	TimedQueue * old;
#line 21 "../src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE));
#line 21 "../src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/TimedQueue.vala"
	if (v_object) {
#line 21 "../src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TIMED_QUEUE));
#line 21 "../src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/TimedQueue.vala"
		timed_queue_ref (value->data[0].v_pointer);
#line 1746 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1750 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	if (old) {
#line 21 "../src/TimedQueue.vala"
		timed_queue_unref (old);
#line 1756 "TimedQueue.c"
	}
}

void
value_take_timed_queue (GValue* value,
                        gpointer v_object)
{
	TimedQueue * old;
#line 21 "../src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE));
#line 21 "../src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/TimedQueue.vala"
	if (v_object) {
#line 21 "../src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TIMED_QUEUE));
#line 21 "../src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 1777 "TimedQueue.c"
	} else {
#line 21 "../src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1781 "TimedQueue.c"
	}
#line 21 "../src/TimedQueue.vala"
	if (old) {
#line 21 "../src/TimedQueue.vala"
		timed_queue_unref (old);
#line 1787 "TimedQueue.c"
	}
}

static void
timed_queue_class_init (TimedQueueClass * klass,
                        gpointer klass_data)
{
#line 21 "../src/TimedQueue.vala"
	timed_queue_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->finalize = timed_queue_finalize;
#line 21 "../src/TimedQueue.vala"
	g_type_class_adjust_private_offset (klass, &TimedQueue_private_offset);
#line 21 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->notify_dequeued = (void (*) (TimedQueue*, gconstpointer)) timed_queue_real_notify_dequeued;
#line 21 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->clear = (void (*) (TimedQueue*)) timed_queue_real_clear;
#line 21 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->contains = (gboolean (*) (TimedQueue*, gconstpointer)) timed_queue_real_contains;
#line 21 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue = (gboolean (*) (TimedQueue*, gconstpointer)) timed_queue_real_enqueue;
#line 21 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue_many = (gboolean (*) (TimedQueue*, GeeCollection*)) timed_queue_real_enqueue_many;
#line 21 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->remove_first = (gboolean (*) (TimedQueue*, gconstpointer)) timed_queue_real_remove_first;
#line 21 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->paused = timed_queue_real_paused;
#line 21 "../src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (klass)->get_size = (gint (*) (TimedQueue*)) timed_queue_real_get_size;
#line 21 "../src/TimedQueue.vala"
	timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL] = g_signal_new ("paused", TYPE_TIMED_QUEUE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (TimedQueueClass, paused), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 1819 "TimedQueue.c"
}

static void
timed_queue_instance_init (TimedQueue * self,
                           gpointer klass)
{
#line 21 "../src/TimedQueue.vala"
	self->priv = timed_queue_get_instance_private (self);
#line 40 "../src/TimedQueue.vala"
	self->priv->timer_id = (guint) 0;
#line 42 "../src/TimedQueue.vala"
	self->priv->dequeue_spacing_msec = (guint) 0;
#line 43 "../src/TimedQueue.vala"
	self->priv->last_dequeue = (gulong) 0;
#line 44 "../src/TimedQueue.vala"
	self->priv->paused_state = FALSE;
#line 21 "../src/TimedQueue.vala"
	self->ref_count = 1;
#line 1838 "TimedQueue.c"
}

static void
timed_queue_finalize (TimedQueue * obj)
{
	TimedQueue * self;
#line 21 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIMED_QUEUE, TimedQueue);
#line 21 "../src/TimedQueue.vala"
	g_signal_handlers_destroy (self);
#line 70 "../src/TimedQueue.vala"
	if (self->priv->timer_id != ((guint) 0)) {
#line 71 "../src/TimedQueue.vala"
		g_source_remove (self->priv->timer_id);
#line 1853 "TimedQueue.c"
	}
#line 38 "../src/TimedQueue.vala"
	(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 38 "../src/TimedQueue.vala"
	self->priv->equal_func = NULL;
#line 38 "../src/TimedQueue.vala"
	self->priv->equal_func_target = NULL;
#line 38 "../src/TimedQueue.vala"
	self->priv->equal_func_target_destroy_notify = NULL;
#line 41 "../src/TimedQueue.vala"
	_g_object_unref0 (self->priv->queue);
#line 1865 "TimedQueue.c"
}

static GType
timed_queue_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_timed_queue_init, value_timed_queue_free_value, value_timed_queue_copy_value, value_timed_queue_peek_pointer, "p", value_timed_queue_collect_value, "p", value_timed_queue_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TimedQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timed_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimedQueue), 0, (GInstanceInitFunc) timed_queue_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType timed_queue_type_id;
	timed_queue_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TimedQueue", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TimedQueue_private_offset = g_type_add_instance_private (timed_queue_type_id, sizeof (TimedQueuePrivate));
	return timed_queue_type_id;
}

GType
timed_queue_get_type (void)
{
	static volatile gsize timed_queue_type_id__once = 0;
	if (g_once_init_enter (&timed_queue_type_id__once)) {
		GType timed_queue_type_id;
		timed_queue_type_id = timed_queue_get_type_once ();
		g_once_init_leave (&timed_queue_type_id__once, timed_queue_type_id);
	}
	return timed_queue_type_id__once;
}

gpointer
timed_queue_ref (gpointer instance)
{
	TimedQueue * self;
	self = instance;
#line 21 "../src/TimedQueue.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/TimedQueue.vala"
	return instance;
#line 1901 "TimedQueue.c"
}

void
timed_queue_unref (gpointer instance)
{
	TimedQueue * self;
	self = instance;
#line 21 "../src/TimedQueue.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/TimedQueue.vala"
		TIMED_QUEUE_GET_CLASS (self)->finalize (self);
#line 21 "../src/TimedQueue.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1915 "TimedQueue.c"
	}
}

static inline gpointer
hash_timed_queue_get_instance_private (HashTimedQueue* self)
{
	return G_STRUCT_MEMBER_P (self, HashTimedQueue_private_offset);
}

HashTimedQueue*
hash_timed_queue_construct (GType object_type,
                            GType g_type,
                            GBoxedCopyFunc g_dup_func,
                            GDestroyNotify g_destroy_func,
                            guint hold_msec,
                            DequeuedCallback callback,
                            gpointer callback_target,
                            GeeHashDataFunc hash_func,
                            gpointer hash_func_target,
                            GDestroyNotify hash_func_target_destroy_notify,
                            GeeEqualDataFunc equal_func,
                            gpointer equal_func_target,
                            GDestroyNotify equal_func_target_destroy_notify,
                            gint priority)
{
	HashTimedQueue* self = NULL;
	GeeEqualDataFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeeHashDataFunc _tmp1_;
	gpointer _tmp1__target;
	GDestroyNotify _tmp1__target_destroy_notify;
	GeeEqualDataFunc _tmp2_;
	gpointer _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	GeeHashMap* _tmp3_;
#line 220 "../src/TimedQueue.vala"
	_tmp0_ = equal_func;
#line 220 "../src/TimedQueue.vala"
	_tmp0__target = equal_func_target;
#line 220 "../src/TimedQueue.vala"
	_tmp0__target_destroy_notify = equal_func_target_destroy_notify;
#line 220 "../src/TimedQueue.vala"
	equal_func = NULL;
#line 220 "../src/TimedQueue.vala"
	equal_func_target = NULL;
#line 220 "../src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 220 "../src/TimedQueue.vala"
	self = (HashTimedQueue*) timed_queue_construct (object_type, g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, hold_msec, callback, callback_target, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify, priority);
#line 220 "../src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 220 "../src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 220 "../src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 222 "../src/TimedQueue.vala"
	_tmp1_ = hash_func;
#line 222 "../src/TimedQueue.vala"
	_tmp1__target = hash_func_target;
#line 222 "../src/TimedQueue.vala"
	_tmp1__target_destroy_notify = hash_func_target_destroy_notify;
#line 222 "../src/TimedQueue.vala"
	hash_func = NULL;
#line 222 "../src/TimedQueue.vala"
	hash_func_target = NULL;
#line 222 "../src/TimedQueue.vala"
	hash_func_target_destroy_notify = NULL;
#line 222 "../src/TimedQueue.vala"
	_tmp2_ = equal_func;
#line 222 "../src/TimedQueue.vala"
	_tmp2__target = equal_func_target;
#line 222 "../src/TimedQueue.vala"
	_tmp2__target_destroy_notify = equal_func_target_destroy_notify;
#line 222 "../src/TimedQueue.vala"
	equal_func = NULL;
#line 222 "../src/TimedQueue.vala"
	equal_func_target = NULL;
#line 222 "../src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 222 "../src/TimedQueue.vala"
	_tmp3_ = gee_hash_map_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, G_TYPE_INT, NULL, NULL, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify, _tmp2_, _tmp2__target, _tmp2__target_destroy_notify, NULL, NULL, NULL);
#line 222 "../src/TimedQueue.vala"
	_g_object_unref0 (self->priv->item_count);
#line 222 "../src/TimedQueue.vala"
	self->priv->item_count = _tmp3_;
#line 217 "../src/TimedQueue.vala"
	(hash_func_target_destroy_notify == NULL) ? NULL : (hash_func_target_destroy_notify (hash_func_target), NULL);
#line 217 "../src/TimedQueue.vala"
	hash_func = NULL;
#line 217 "../src/TimedQueue.vala"
	hash_func_target = NULL;
#line 217 "../src/TimedQueue.vala"
	hash_func_target_destroy_notify = NULL;
#line 217 "../src/TimedQueue.vala"
	(equal_func_target_destroy_notify == NULL) ? NULL : (equal_func_target_destroy_notify (equal_func_target), NULL);
#line 217 "../src/TimedQueue.vala"
	equal_func = NULL;
#line 217 "../src/TimedQueue.vala"
	equal_func_target = NULL;
#line 217 "../src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 217 "../src/TimedQueue.vala"
	return self;
#line 2020 "TimedQueue.c"
}

HashTimedQueue*
hash_timed_queue_new (GType g_type,
                      GBoxedCopyFunc g_dup_func,
                      GDestroyNotify g_destroy_func,
                      guint hold_msec,
                      DequeuedCallback callback,
                      gpointer callback_target,
                      GeeHashDataFunc hash_func,
                      gpointer hash_func_target,
                      GDestroyNotify hash_func_target_destroy_notify,
                      GeeEqualDataFunc equal_func,
                      gpointer equal_func_target,
                      GDestroyNotify equal_func_target_destroy_notify,
                      gint priority)
{
#line 217 "../src/TimedQueue.vala"
	return hash_timed_queue_construct (TYPE_HASH_TIMED_QUEUE, g_type, g_dup_func, g_destroy_func, hold_msec, callback, callback_target, hash_func, hash_func_target, hash_func_target_destroy_notify, equal_func, equal_func_target, equal_func_target_destroy_notify, priority);
#line 2040 "TimedQueue.c"
}

static void
hash_timed_queue_real_notify_dequeued (TimedQueue* base,
                                       gconstpointer item)
{
	HashTimedQueue * self;
#line 225 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 226 "../src/TimedQueue.vala"
	hash_timed_queue_removed (self, item);
#line 228 "../src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->notify_dequeued (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), item);
#line 2054 "TimedQueue.c"
}

static void
hash_timed_queue_real_clear (TimedQueue* base)
{
	HashTimedQueue * self;
	GeeHashMap* _tmp0_;
#line 231 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 232 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 232 "../src/TimedQueue.vala"
	gee_abstract_map_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 234 "../src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue));
#line 2070 "TimedQueue.c"
}

static gboolean
hash_timed_queue_real_contains (TimedQueue* base,
                                gconstpointer item)
{
	HashTimedQueue * self;
	GeeHashMap* _tmp0_;
	gboolean result;
#line 237 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 238 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 238 "../src/TimedQueue.vala"
	result = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item);
#line 238 "../src/TimedQueue.vala"
	return result;
#line 2088 "TimedQueue.c"
}

static gboolean
hash_timed_queue_real_enqueue (TimedQueue* base,
                               gconstpointer item)
{
	HashTimedQueue * self;
	gint _tmp0_ = 0;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp4_;
	gboolean result;
#line 241 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 242 "../src/TimedQueue.vala"
	if (!TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->enqueue (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), item)) {
#line 243 "../src/TimedQueue.vala"
		result = FALSE;
#line 243 "../src/TimedQueue.vala"
		return result;
#line 2108 "TimedQueue.c"
	}
#line 245 "../src/TimedQueue.vala"
	_tmp1_ = self->priv->item_count;
#line 245 "../src/TimedQueue.vala"
	if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item)) {
#line 2114 "TimedQueue.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
#line 245 "../src/TimedQueue.vala"
		_tmp2_ = self->priv->item_count;
#line 245 "../src/TimedQueue.vala"
		_tmp3_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item);
#line 245 "../src/TimedQueue.vala"
		_tmp0_ = ((gint) ((gintptr) _tmp3_)) + 1;
#line 2123 "TimedQueue.c"
	} else {
#line 245 "../src/TimedQueue.vala"
		_tmp0_ = 1;
#line 2127 "TimedQueue.c"
	}
#line 245 "../src/TimedQueue.vala"
	_tmp4_ = self->priv->item_count;
#line 245 "../src/TimedQueue.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item, (gpointer) ((gintptr) _tmp0_));
#line 247 "../src/TimedQueue.vala"
	result = TRUE;
#line 247 "../src/TimedQueue.vala"
	return result;
#line 2137 "TimedQueue.c"
}

static gboolean
hash_timed_queue_real_enqueue_many (TimedQueue* base,
                                    GeeCollection* items)
{
	HashTimedQueue * self;
	gboolean result;
#line 250 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 250 "../src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (items, GEE_TYPE_COLLECTION), FALSE);
#line 251 "../src/TimedQueue.vala"
	if (!TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->enqueue_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), items)) {
#line 252 "../src/TimedQueue.vala"
		result = FALSE;
#line 252 "../src/TimedQueue.vala"
		return result;
#line 2156 "TimedQueue.c"
	}
	{
		GeeIterator* _item_it = NULL;
		GeeIterator* _tmp0_;
#line 254 "../src/TimedQueue.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (items, GEE_TYPE_ITERABLE, GeeIterable));
#line 254 "../src/TimedQueue.vala"
		_item_it = _tmp0_;
#line 254 "../src/TimedQueue.vala"
		while (TRUE) {
#line 2167 "TimedQueue.c"
			GeeIterator* _tmp1_;
			gpointer item = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			gint _tmp4_ = 0;
			GeeHashMap* _tmp5_;
			gconstpointer _tmp6_;
			GeeHashMap* _tmp10_;
			gconstpointer _tmp11_;
#line 254 "../src/TimedQueue.vala"
			_tmp1_ = _item_it;
#line 254 "../src/TimedQueue.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 254 "../src/TimedQueue.vala"
				break;
#line 2183 "TimedQueue.c"
			}
#line 254 "../src/TimedQueue.vala"
			_tmp2_ = _item_it;
#line 254 "../src/TimedQueue.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 254 "../src/TimedQueue.vala"
			item = _tmp3_;
#line 255 "../src/TimedQueue.vala"
			_tmp5_ = self->priv->item_count;
#line 255 "../src/TimedQueue.vala"
			_tmp6_ = item;
#line 255 "../src/TimedQueue.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp6_)) {
#line 2197 "TimedQueue.c"
				GeeHashMap* _tmp7_;
				gconstpointer _tmp8_;
				gpointer _tmp9_;
#line 255 "../src/TimedQueue.vala"
				_tmp7_ = self->priv->item_count;
#line 255 "../src/TimedQueue.vala"
				_tmp8_ = item;
#line 255 "../src/TimedQueue.vala"
				_tmp9_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_);
#line 255 "../src/TimedQueue.vala"
				_tmp4_ = ((gint) ((gintptr) _tmp9_)) + 1;
#line 2209 "TimedQueue.c"
			} else {
#line 255 "../src/TimedQueue.vala"
				_tmp4_ = 1;
#line 2213 "TimedQueue.c"
			}
#line 255 "../src/TimedQueue.vala"
			_tmp10_ = self->priv->item_count;
#line 255 "../src/TimedQueue.vala"
			_tmp11_ = item;
#line 255 "../src/TimedQueue.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_, (gpointer) ((gintptr) _tmp4_));
#line 254 "../src/TimedQueue.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 2223 "TimedQueue.c"
		}
#line 254 "../src/TimedQueue.vala"
		_g_object_unref0 (_item_it);
#line 2227 "TimedQueue.c"
	}
#line 257 "../src/TimedQueue.vala"
	result = TRUE;
#line 257 "../src/TimedQueue.vala"
	return result;
#line 2233 "TimedQueue.c"
}

static gboolean
hash_timed_queue_real_remove_first (TimedQueue* base,
                                    gconstpointer item)
{
	HashTimedQueue * self;
	gboolean result;
#line 260 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 261 "../src/TimedQueue.vala"
	if (!TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->remove_first (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), item)) {
#line 262 "../src/TimedQueue.vala"
		result = FALSE;
#line 262 "../src/TimedQueue.vala"
		return result;
#line 2250 "TimedQueue.c"
	}
#line 264 "../src/TimedQueue.vala"
	hash_timed_queue_removed (self, item);
#line 266 "../src/TimedQueue.vala"
	result = TRUE;
#line 266 "../src/TimedQueue.vala"
	return result;
#line 2258 "TimedQueue.c"
}

static void
hash_timed_queue_removed (HashTimedQueue* self,
                          gconstpointer item)
{
	GeeHashMap* _tmp0_;
	gint count = 0;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	gint _tmp3_;
#line 269 "../src/TimedQueue.vala"
	g_return_if_fail (IS_HASH_TIMED_QUEUE (self));
#line 272 "../src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 272 "../src/TimedQueue.vala"
	if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item)) {
#line 273 "../src/TimedQueue.vala"
		return;
#line 2278 "TimedQueue.c"
	}
#line 275 "../src/TimedQueue.vala"
	_tmp1_ = self->priv->item_count;
#line 275 "../src/TimedQueue.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item);
#line 275 "../src/TimedQueue.vala"
	count = (gint) ((gintptr) _tmp2_);
#line 276 "../src/TimedQueue.vala"
	_vala_assert (count > 0, "count > 0");
#line 278 "../src/TimedQueue.vala"
	count = count - 1;
#line 278 "../src/TimedQueue.vala"
	_tmp3_ = count;
#line 278 "../src/TimedQueue.vala"
	if (_tmp3_ == 0) {
#line 2294 "TimedQueue.c"
		GeeHashMap* _tmp4_;
#line 279 "../src/TimedQueue.vala"
		_tmp4_ = self->priv->item_count;
#line 279 "../src/TimedQueue.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item, NULL);
#line 2300 "TimedQueue.c"
	} else {
		GeeHashMap* _tmp5_;
#line 281 "../src/TimedQueue.vala"
		_tmp5_ = self->priv->item_count;
#line 281 "../src/TimedQueue.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), item, (gpointer) ((gintptr) count));
#line 2307 "TimedQueue.c"
	}
}

static void
hash_timed_queue_class_init (HashTimedQueueClass * klass,
                             gpointer klass_data)
{
#line 214 "../src/TimedQueue.vala"
	hash_timed_queue_parent_class = g_type_class_peek_parent (klass);
#line 214 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->finalize = hash_timed_queue_finalize;
#line 214 "../src/TimedQueue.vala"
	g_type_class_adjust_private_offset (klass, &HashTimedQueue_private_offset);
#line 214 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->notify_dequeued = (void (*) (TimedQueue*, gconstpointer)) hash_timed_queue_real_notify_dequeued;
#line 214 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->clear = (void (*) (TimedQueue*)) hash_timed_queue_real_clear;
#line 214 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->contains = (gboolean (*) (TimedQueue*, gconstpointer)) hash_timed_queue_real_contains;
#line 214 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue = (gboolean (*) (TimedQueue*, gconstpointer)) hash_timed_queue_real_enqueue;
#line 214 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue_many = (gboolean (*) (TimedQueue*, GeeCollection*)) hash_timed_queue_real_enqueue_many;
#line 214 "../src/TimedQueue.vala"
	((TimedQueueClass *) klass)->remove_first = (gboolean (*) (TimedQueue*, gconstpointer)) hash_timed_queue_real_remove_first;
#line 2333 "TimedQueue.c"
}

static void
hash_timed_queue_instance_init (HashTimedQueue * self,
                                gpointer klass)
{
#line 214 "../src/TimedQueue.vala"
	self->priv = hash_timed_queue_get_instance_private (self);
#line 2342 "TimedQueue.c"
}

static void
hash_timed_queue_finalize (TimedQueue * obj)
{
	HashTimedQueue * self;
#line 214 "../src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 215 "../src/TimedQueue.vala"
	_g_object_unref0 (self->priv->item_count);
#line 214 "../src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->finalize (obj);
#line 2355 "TimedQueue.c"
}

static GType
hash_timed_queue_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HashTimedQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hash_timed_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HashTimedQueue), 0, (GInstanceInitFunc) hash_timed_queue_instance_init, NULL };
	GType hash_timed_queue_type_id;
	hash_timed_queue_type_id = g_type_register_static (TYPE_TIMED_QUEUE, "HashTimedQueue", &g_define_type_info, 0);
	HashTimedQueue_private_offset = g_type_add_instance_private (hash_timed_queue_type_id, sizeof (HashTimedQueuePrivate));
	return hash_timed_queue_type_id;
}

GType
hash_timed_queue_get_type (void)
{
	static volatile gsize hash_timed_queue_type_id__once = 0;
	if (g_once_init_enter (&hash_timed_queue_type_id__once)) {
		GType hash_timed_queue_type_id;
		hash_timed_queue_type_id = hash_timed_queue_get_type_once ();
		g_once_init_leave (&hash_timed_queue_type_id__once, hash_timed_queue_type_id);
	}
	return hash_timed_queue_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

