/* AVIMetadataLoader.c generated by valac 0.56.17, the Vala compiler
 * generated from AVIMetadataLoader.vala, do not modify */

#include "shotwell-internal-video-metadata-handling.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include "metadata.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define AVI_METADATA_LOADER_NUMERICAL_DATE_LENGTH 19
#define AVI_METADATA_LOADER_NIKON_NCTG_TIMESTAMP_MARKER ((guint16) 0x13)
#define AVI_METADATA_LOADER_MAX_STRD_LENGTH 100
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define TYPE_AVI_CHUNK (avi_chunk_get_type ())
#define AVI_CHUNK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AVI_CHUNK, AVIChunk))
#define AVI_CHUNK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AVI_CHUNK, AVIChunkClass))
#define IS_AVI_CHUNK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AVI_CHUNK))
#define IS_AVI_CHUNK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AVI_CHUNK))
#define AVI_CHUNK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AVI_CHUNK, AVIChunkClass))

typedef struct _AVIChunk AVIChunk;
typedef struct _AVIChunkClass AVIChunkClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _avi_chunk_unref0(var) ((var == NULL) ? NULL : (var = (avi_chunk_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ParamSpecAVIMetadataLoader ParamSpecAVIMetadataLoader;

struct _AVIMetadataLoaderPrivate {
	GFile* file;
};

struct _ParamSpecAVIMetadataLoader {
	GParamSpec parent_instance;
};

static gint AVIMetadataLoader_private_offset;
static gpointer avi_metadata_loader_parent_class = NULL;

static GDateTime* avi_metadata_loader_get_creation_date_time_for_avi (AVIMetadataLoader* self);
VALA_EXTERN gpointer avi_chunk_ref (gpointer instance);
VALA_EXTERN void avi_chunk_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_avi_chunk (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_avi_chunk (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_avi_chunk (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_avi_chunk (const GValue* value);
VALA_EXTERN GType avi_chunk_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AVIChunk* avi_chunk_new (GFile* file);
VALA_EXTERN AVIChunk* avi_chunk_construct (GType object_type,
                               GFile* file);
VALA_EXTERN void avi_chunk_open_file (AVIChunk* self,
                          GError** error);
VALA_EXTERN void avi_chunk_read_chunk (AVIChunk* self,
                           GError** error);
VALA_EXTERN gchar* avi_chunk_get_current_chunk_name (AVIChunk* self);
VALA_EXTERN gchar* avi_chunk_read_name (AVIChunk* self,
                            GError** error);
VALA_EXTERN void avi_chunk_close_file (AVIChunk* self,
                           GError** error);
static gchar* avi_metadata_loader_read_nikon_nctg_tag (AVIMetadataLoader* self,
                                                AVIChunk* chunk,
                                                GError** error);
VALA_EXTERN guint64 avi_chunk_section_size_remaining (AVIChunk* self);
VALA_EXTERN guint16 avi_chunk_read_uint16 (AVIChunk* self,
                               GError** error);
VALA_EXTERN void avi_chunk_skip (AVIChunk* self,
                     guint64 skip_amount,
                     GError** error);
VALA_EXTERN guchar avi_chunk_read_byte (AVIChunk* self,
                            GError** error);
static gchar* avi_metadata_loader_read_fuji_strd_tag (AVIMetadataLoader* self,
                                               AVIChunk* chunk,
                                               GError** error);
static gchar* avi_metadata_loader_read_section (AVIMetadataLoader* self,
                                         AVIChunk* chunk,
                                         GError** error);
VALA_EXTERN gchar* avi_chunk_section_to_string (AVIChunk* self,
                                    GError** error);
VALA_EXTERN AVIChunk* avi_chunk_get_first_child_chunk (AVIChunk* self);
VALA_EXTERN gboolean avi_chunk_is_last_chunk (AVIChunk* self);
VALA_EXTERN void avi_chunk_next_chunk (AVIChunk* self,
                           GError** error);
static GDateTime* avi_metadata_loader_parse_date (AVIMetadataLoader* self,
                                           const gchar* sdate);
static GDateMonth avi_metadata_loader_month_from_string (AVIMetadataLoader* self,
                                                  const gchar* s);
VALA_EXTERN void avi_chunk_nonsection_skip (AVIChunk* self,
                                guint64 skip_amount,
                                GError** error);
static void avi_metadata_loader_finalize (AVIMetadataLoader * obj);
static GType avi_metadata_loader_get_type_once (void);

static inline gpointer
avi_metadata_loader_get_instance_private (AVIMetadataLoader* self)
{
	return G_STRUCT_MEMBER_P (self, AVIMetadataLoader_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 15 "../src/video-support/AVIMetadataLoader.vala"
	return self ? g_object_ref (self) : NULL;
#line 128 "AVIMetadataLoader.c"
}

AVIMetadataLoader*
avi_metadata_loader_construct (GType object_type,
                               GFile* file)
{
	AVIMetadataLoader* self = NULL;
	GFile* _tmp0_;
#line 14 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 14 "../src/video-support/AVIMetadataLoader.vala"
	self = (AVIMetadataLoader*) g_type_create_instance (object_type);
#line 15 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 15 "../src/video-support/AVIMetadataLoader.vala"
	_g_object_unref0 (self->priv->file);
#line 15 "../src/video-support/AVIMetadataLoader.vala"
	self->priv->file = _tmp0_;
#line 14 "../src/video-support/AVIMetadataLoader.vala"
	return self;
#line 149 "AVIMetadataLoader.c"
}

AVIMetadataLoader*
avi_metadata_loader_new (GFile* file)
{
#line 14 "../src/video-support/AVIMetadataLoader.vala"
	return avi_metadata_loader_construct (TYPE_AVI_METADATA_LOADER, file);
#line 157 "AVIMetadataLoader.c"
}

MetadataDateTime*
avi_metadata_loader_get_creation_date_time (AVIMetadataLoader* self)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	MetadataDateTime* _tmp2_;
	MetadataDateTime* _tmp3_;
	MetadataDateTime* result;
#line 18 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = avi_metadata_loader_get_creation_date_time_for_avi (self);
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = _tmp0_;
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	_tmp2_ = metadata_date_time_new (_tmp1_);
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	_tmp3_ = _tmp2_;
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	_g_date_time_unref0 (_tmp1_);
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	result = _tmp3_;
#line 19 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 184 "AVIMetadataLoader.c"
}

gchar*
avi_metadata_loader_get_title (AVIMetadataLoader* self)
{
	gchar* result;
#line 22 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 24 "../src/video-support/AVIMetadataLoader.vala"
	result = NULL;
#line 24 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 197 "AVIMetadataLoader.c"
}

gboolean
avi_metadata_loader_is_supported (AVIMetadataLoader* self)
{
	AVIChunk* chunk = NULL;
	GFile* _tmp0_;
	AVIChunk* _tmp1_;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 28 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), FALSE);
#line 29 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = self->priv->file;
#line 29 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = avi_chunk_new (_tmp0_);
#line 29 "../src/video-support/AVIMetadataLoader.vala"
	chunk = _tmp1_;
#line 30 "../src/video-support/AVIMetadataLoader.vala"
	ret = FALSE;
#line 219 "AVIMetadataLoader.c"
	{
		AVIChunk* _tmp2_;
		AVIChunk* _tmp3_;
		gboolean _tmp4_ = FALSE;
		AVIChunk* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
#line 32 "../src/video-support/AVIMetadataLoader.vala"
		_tmp2_ = chunk;
#line 32 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_open_file (_tmp2_, &_inner_error0_);
#line 32 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 33 "../src/video-support/AVIMetadataLoader.vala"
		_tmp3_ = chunk;
#line 33 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_read_chunk (_tmp3_, &_inner_error0_);
#line 33 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 243 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_tmp5_ = chunk;
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_tmp6_ = avi_chunk_get_current_chunk_name (_tmp5_);
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_tmp7_ = _tmp6_;
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_tmp8_ = g_strcmp0 ("RIFF", _tmp7_) == 0;
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (_tmp7_);
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		if (_tmp8_) {
#line 258 "AVIMetadataLoader.c"
			gchar* _tmp9_ = NULL;
			AVIChunk* _tmp10_;
			gchar* _tmp11_;
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			_tmp10_ = chunk;
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			_tmp11_ = avi_chunk_read_name (_tmp10_, &_inner_error0_);
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			_tmp9_ = _tmp11_;
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 270 "AVIMetadataLoader.c"
				goto __catch0_g_error;
			}
#line 36 "../src/video-support/AVIMetadataLoader.vala"
			_tmp4_ = g_strcmp0 ("AVI ", _tmp9_) == 0;
#line 35 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_tmp9_);
#line 277 "AVIMetadataLoader.c"
		} else {
#line 35 "../src/video-support/AVIMetadataLoader.vala"
			_tmp4_ = FALSE;
#line 281 "AVIMetadataLoader.c"
		}
#line 35 "../src/video-support/AVIMetadataLoader.vala"
		if (_tmp4_) {
#line 37 "../src/video-support/AVIMetadataLoader.vala"
			ret = TRUE;
#line 287 "AVIMetadataLoader.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		e = _inner_error0_;
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		_inner_error0_ = NULL;
#line 40 "../src/video-support/AVIMetadataLoader.vala"
		_tmp12_ = e;
#line 40 "../src/video-support/AVIMetadataLoader.vala"
		_tmp13_ = _tmp12_->message;
#line 40 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:40: Error while testing for AVI file: %s", _tmp13_);
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		_g_error_free0 (e);
#line 308 "AVIMetadataLoader.c"
	}
	__finally0:
#line 31 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "AVIMetadataLoader.c"
		gboolean _tmp14_ = FALSE;
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		_avi_chunk_unref0 (chunk);
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		g_clear_error (&_inner_error0_);
#line 31 "../src/video-support/AVIMetadataLoader.vala"
		return _tmp14_;
#line 323 "AVIMetadataLoader.c"
	}
	{
		AVIChunk* _tmp15_;
#line 44 "../src/video-support/AVIMetadataLoader.vala"
		_tmp15_ = chunk;
#line 44 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_close_file (_tmp15_, &_inner_error0_);
#line 44 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 333 "AVIMetadataLoader.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		e = _inner_error0_;
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		_inner_error0_ = NULL;
#line 46 "../src/video-support/AVIMetadataLoader.vala"
		_tmp16_ = e;
#line 46 "../src/video-support/AVIMetadataLoader.vala"
		_tmp17_ = _tmp16_->message;
#line 46 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:46: Error while closing AVI file: %s", _tmp17_);
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		_g_error_free0 (e);
#line 355 "AVIMetadataLoader.c"
	}
	__finally1:
#line 43 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "AVIMetadataLoader.c"
		gboolean _tmp18_ = FALSE;
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		_avi_chunk_unref0 (chunk);
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		g_clear_error (&_inner_error0_);
#line 43 "../src/video-support/AVIMetadataLoader.vala"
		return _tmp18_;
#line 370 "AVIMetadataLoader.c"
	}
#line 48 "../src/video-support/AVIMetadataLoader.vala"
	result = ret;
#line 48 "../src/video-support/AVIMetadataLoader.vala"
	_avi_chunk_unref0 (chunk);
#line 48 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 378 "AVIMetadataLoader.c"
}

static gchar*
avi_metadata_loader_read_nikon_nctg_tag (AVIMetadataLoader* self,
                                         AVIChunk* chunk,
                                         GError** error)
{
	gboolean found_date = FALSE;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 52 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 52 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_CHUNK (chunk), NULL);
#line 53 "../src/video-support/AVIMetadataLoader.vala"
	found_date = FALSE;
#line 54 "../src/video-support/AVIMetadataLoader.vala"
	while (TRUE) {
#line 398 "AVIMetadataLoader.c"
		guint16 tag = 0U;
		guint16 size = 0U;
#line 54 "../src/video-support/AVIMetadataLoader.vala"
		if (!(avi_chunk_section_size_remaining (chunk) > ((guint64) (sizeof (guint16) * 2)))) {
#line 54 "../src/video-support/AVIMetadataLoader.vala"
			break;
#line 405 "AVIMetadataLoader.c"
		}
#line 55 "../src/video-support/AVIMetadataLoader.vala"
		tag = avi_chunk_read_uint16 (chunk, &_inner_error0_);
#line 55 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 55 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 415 "AVIMetadataLoader.c"
		}
#line 56 "../src/video-support/AVIMetadataLoader.vala"
		size = avi_chunk_read_uint16 (chunk, &_inner_error0_);
#line 56 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 56 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 425 "AVIMetadataLoader.c"
		}
#line 57 "../src/video-support/AVIMetadataLoader.vala"
		if (AVI_METADATA_LOADER_NIKON_NCTG_TIMESTAMP_MARKER == tag) {
#line 58 "../src/video-support/AVIMetadataLoader.vala"
			found_date = TRUE;
#line 59 "../src/video-support/AVIMetadataLoader.vala"
			break;
#line 433 "AVIMetadataLoader.c"
		}
#line 61 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_skip (chunk, (guint64) size, &_inner_error0_);
#line 61 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 61 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 443 "AVIMetadataLoader.c"
		}
	}
#line 64 "../src/video-support/AVIMetadataLoader.vala"
	if (found_date) {
#line 448 "AVIMetadataLoader.c"
		GString* sb = NULL;
		GString* _tmp0_;
		GString* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 66 "../src/video-support/AVIMetadataLoader.vala"
		_tmp0_ = g_string_new ("");
#line 66 "../src/video-support/AVIMetadataLoader.vala"
		sb = _tmp0_;
#line 458 "AVIMetadataLoader.c"
		{
			gint i = 0;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
			i = 0;
#line 463 "AVIMetadataLoader.c"
			{
				gboolean _tmp1_ = FALSE;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
				_tmp1_ = TRUE;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
				while (TRUE) {
#line 470 "AVIMetadataLoader.c"
					guchar _tmp3_ = '\0';
					GString* _tmp4_;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
					if (!_tmp1_) {
#line 475 "AVIMetadataLoader.c"
						gint _tmp2_;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
						_tmp2_ = i;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
						i = _tmp2_ + 1;
#line 481 "AVIMetadataLoader.c"
					}
#line 67 "../src/video-support/AVIMetadataLoader.vala"
					_tmp1_ = FALSE;
#line 67 "../src/video-support/AVIMetadataLoader.vala"
					if (!(i < AVI_METADATA_LOADER_NUMERICAL_DATE_LENGTH)) {
#line 67 "../src/video-support/AVIMetadataLoader.vala"
						break;
#line 489 "AVIMetadataLoader.c"
					}
#line 68 "../src/video-support/AVIMetadataLoader.vala"
					_tmp3_ = avi_chunk_read_byte (chunk, &_inner_error0_);
#line 68 "../src/video-support/AVIMetadataLoader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/video-support/AVIMetadataLoader.vala"
						g_propagate_error (error, _inner_error0_);
#line 68 "../src/video-support/AVIMetadataLoader.vala"
						_g_string_free0 (sb);
#line 68 "../src/video-support/AVIMetadataLoader.vala"
						return NULL;
#line 501 "AVIMetadataLoader.c"
					}
#line 68 "../src/video-support/AVIMetadataLoader.vala"
					_tmp4_ = sb;
#line 68 "../src/video-support/AVIMetadataLoader.vala"
					g_string_append_c (_tmp4_, (gchar) _tmp3_);
#line 507 "AVIMetadataLoader.c"
				}
			}
		}
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		_tmp5_ = sb;
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		_tmp6_ = _tmp5_->str;
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		result = _tmp7_;
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		_g_string_free0 (sb);
#line 70 "../src/video-support/AVIMetadataLoader.vala"
		return result;
#line 523 "AVIMetadataLoader.c"
	}
#line 72 "../src/video-support/AVIMetadataLoader.vala"
	_tmp8_ = g_strdup ("");
#line 72 "../src/video-support/AVIMetadataLoader.vala"
	result = _tmp8_;
#line 72 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 531 "AVIMetadataLoader.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 554 "AVIMetadataLoader.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 563 "AVIMetadataLoader.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 582 "AVIMetadataLoader.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 586 "AVIMetadataLoader.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 592 "AVIMetadataLoader.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 602 "AVIMetadataLoader.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 610 "AVIMetadataLoader.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 614 "AVIMetadataLoader.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 620 "AVIMetadataLoader.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 630 "AVIMetadataLoader.c"
}

static gchar*
avi_metadata_loader_read_fuji_strd_tag (AVIMetadataLoader* self,
                                        AVIChunk* chunk,
                                        GError** error)
{
	gint colons = 0;
	gint post_colons = 0;
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp8_;
	const gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GString* _tmp13_;
	const gchar* _tmp14_;
	GString* _tmp15_;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 77 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 77 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_CHUNK (chunk), NULL);
#line 78 "../src/video-support/AVIMetadataLoader.vala"
	avi_chunk_skip (chunk, (guint64) 98, &_inner_error0_);
#line 78 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../src/video-support/AVIMetadataLoader.vala"
		g_propagate_error (error, _inner_error0_);
#line 78 "../src/video-support/AVIMetadataLoader.vala"
		return NULL;
#line 667 "AVIMetadataLoader.c"
	}
#line 79 "../src/video-support/AVIMetadataLoader.vala"
	avi_chunk_skip (chunk, (guint64) 8, &_inner_error0_);
#line 79 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/video-support/AVIMetadataLoader.vala"
		g_propagate_error (error, _inner_error0_);
#line 79 "../src/video-support/AVIMetadataLoader.vala"
		return NULL;
#line 677 "AVIMetadataLoader.c"
	}
#line 81 "../src/video-support/AVIMetadataLoader.vala"
	colons = 0;
#line 82 "../src/video-support/AVIMetadataLoader.vala"
	post_colons = 0;
#line 83 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = g_string_new ("");
#line 83 "../src/video-support/AVIMetadataLoader.vala"
	sb = _tmp0_;
#line 85 "../src/video-support/AVIMetadataLoader.vala"
	while (TRUE) {
#line 689 "AVIMetadataLoader.c"
		gboolean _tmp1_ = FALSE;
		guchar _tmp2_ = '\0';
		gchar c = '\0';
		GString* _tmp6_;
#line 85 "../src/video-support/AVIMetadataLoader.vala"
		if (colons <= 4) {
#line 85 "../src/video-support/AVIMetadataLoader.vala"
			_tmp1_ = post_colons < 2;
#line 698 "AVIMetadataLoader.c"
		} else {
#line 85 "../src/video-support/AVIMetadataLoader.vala"
			_tmp1_ = FALSE;
#line 702 "AVIMetadataLoader.c"
		}
#line 85 "../src/video-support/AVIMetadataLoader.vala"
		if (!_tmp1_) {
#line 85 "../src/video-support/AVIMetadataLoader.vala"
			break;
#line 708 "AVIMetadataLoader.c"
		}
#line 86 "../src/video-support/AVIMetadataLoader.vala"
		_tmp2_ = avi_chunk_read_byte (chunk, &_inner_error0_);
#line 86 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 86 "../src/video-support/AVIMetadataLoader.vala"
			_g_string_free0 (sb);
#line 86 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 720 "AVIMetadataLoader.c"
		}
#line 86 "../src/video-support/AVIMetadataLoader.vala"
		c = (gchar) _tmp2_;
#line 87 "../src/video-support/AVIMetadataLoader.vala"
		if (4 == colons) {
#line 726 "AVIMetadataLoader.c"
			gint _tmp3_;
#line 88 "../src/video-support/AVIMetadataLoader.vala"
			_tmp3_ = post_colons;
#line 88 "../src/video-support/AVIMetadataLoader.vala"
			post_colons = _tmp3_ + 1;
#line 732 "AVIMetadataLoader.c"
		}
#line 90 "../src/video-support/AVIMetadataLoader.vala"
		if (':' == c) {
#line 736 "AVIMetadataLoader.c"
			gint _tmp4_;
#line 91 "../src/video-support/AVIMetadataLoader.vala"
			_tmp4_ = colons;
#line 91 "../src/video-support/AVIMetadataLoader.vala"
			colons = _tmp4_ + 1;
#line 742 "AVIMetadataLoader.c"
		}
#line 93 "../src/video-support/AVIMetadataLoader.vala"
		if (g_ascii_isprint (c)) {
#line 746 "AVIMetadataLoader.c"
			GString* _tmp5_;
#line 94 "../src/video-support/AVIMetadataLoader.vala"
			_tmp5_ = sb;
#line 94 "../src/video-support/AVIMetadataLoader.vala"
			g_string_append_c (_tmp5_, c);
#line 752 "AVIMetadataLoader.c"
		}
#line 96 "../src/video-support/AVIMetadataLoader.vala"
		_tmp6_ = sb;
#line 96 "../src/video-support/AVIMetadataLoader.vala"
		if (_tmp6_->len > ((gssize) AVI_METADATA_LOADER_MAX_STRD_LENGTH)) {
#line 758 "AVIMetadataLoader.c"
			gchar* _tmp7_;
#line 97 "../src/video-support/AVIMetadataLoader.vala"
			_tmp7_ = g_strdup ("");
#line 97 "../src/video-support/AVIMetadataLoader.vala"
			result = _tmp7_;
#line 97 "../src/video-support/AVIMetadataLoader.vala"
			_g_string_free0 (sb);
#line 97 "../src/video-support/AVIMetadataLoader.vala"
			return result;
#line 768 "AVIMetadataLoader.c"
		}
	}
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	_tmp8_ = sb;
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	_tmp9_ = _tmp8_->str;
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	_tmp10_ = strlen (_tmp9_);
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	_tmp11_ = _tmp10_;
#line 101 "../src/video-support/AVIMetadataLoader.vala"
	if (_tmp11_ < AVI_METADATA_LOADER_NUMERICAL_DATE_LENGTH) {
#line 781 "AVIMetadataLoader.c"
		gchar* _tmp12_;
#line 102 "../src/video-support/AVIMetadataLoader.vala"
		_tmp12_ = g_strdup ("");
#line 102 "../src/video-support/AVIMetadataLoader.vala"
		result = _tmp12_;
#line 102 "../src/video-support/AVIMetadataLoader.vala"
		_g_string_free0 (sb);
#line 102 "../src/video-support/AVIMetadataLoader.vala"
		return result;
#line 791 "AVIMetadataLoader.c"
	}
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp13_ = sb;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp14_ = _tmp13_->str;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp15_ = sb;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp16_ = _tmp15_->str;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp17_ = strlen (_tmp16_);
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp18_ = _tmp17_;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_tmp19_ = string_substring (_tmp14_, (glong) (_tmp18_ - AVI_METADATA_LOADER_NUMERICAL_DATE_LENGTH), (glong) -1);
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	result = _tmp19_;
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	_g_string_free0 (sb);
#line 105 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 813 "AVIMetadataLoader.c"
}

static gchar*
avi_metadata_loader_read_section (AVIMetadataLoader* self,
                                  AVIChunk* chunk,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 109 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 109 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_CHUNK (chunk), NULL);
#line 110 "../src/video-support/AVIMetadataLoader.vala"
	while (TRUE) {
#line 829 "AVIMetadataLoader.c"
		gchar* name = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp13_;
#line 111 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_read_chunk (chunk, &_inner_error0_);
#line 111 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 111 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 842 "AVIMetadataLoader.c"
		}
#line 112 "../src/video-support/AVIMetadataLoader.vala"
		_tmp0_ = avi_chunk_get_current_chunk_name (chunk);
#line 112 "../src/video-support/AVIMetadataLoader.vala"
		name = _tmp0_;
#line 113 "../src/video-support/AVIMetadataLoader.vala"
		_tmp1_ = name;
#line 113 "../src/video-support/AVIMetadataLoader.vala"
		if (g_strcmp0 ("IDIT", _tmp1_) == 0) {
#line 852 "AVIMetadataLoader.c"
			gchar* _tmp2_ = NULL;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_tmp3_ = avi_chunk_section_to_string (chunk, &_inner_error0_);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_tmp2_ = _tmp3_;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../src/video-support/AVIMetadataLoader.vala"
				g_propagate_error (error, _inner_error0_);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
				return NULL;
#line 868 "AVIMetadataLoader.c"
			}
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_tmp4_ = _tmp2_;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_tmp2_ = NULL;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			result = _tmp4_;
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_tmp2_);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (name);
#line 114 "../src/video-support/AVIMetadataLoader.vala"
			return result;
#line 882 "AVIMetadataLoader.c"
		} else {
			const gchar* _tmp5_;
#line 115 "../src/video-support/AVIMetadataLoader.vala"
			_tmp5_ = name;
#line 115 "../src/video-support/AVIMetadataLoader.vala"
			if (g_strcmp0 ("nctg", _tmp5_) == 0) {
#line 889 "AVIMetadataLoader.c"
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_tmp7_ = avi_metadata_loader_read_nikon_nctg_tag (self, chunk, &_inner_error0_);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_tmp6_ = _tmp7_;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/video-support/AVIMetadataLoader.vala"
					g_propagate_error (error, _inner_error0_);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
					_g_free0 (name);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
					return NULL;
#line 905 "AVIMetadataLoader.c"
				}
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_tmp8_ = _tmp6_;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_tmp6_ = NULL;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				result = _tmp8_;
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (_tmp6_);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 116 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 919 "AVIMetadataLoader.c"
			} else {
				const gchar* _tmp9_;
#line 117 "../src/video-support/AVIMetadataLoader.vala"
				_tmp9_ = name;
#line 117 "../src/video-support/AVIMetadataLoader.vala"
				if (g_strcmp0 ("strd", _tmp9_) == 0) {
#line 926 "AVIMetadataLoader.c"
					gchar* _tmp10_ = NULL;
					gchar* _tmp11_;
					gchar* _tmp12_;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_tmp11_ = avi_metadata_loader_read_fuji_strd_tag (self, chunk, &_inner_error0_);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_tmp10_ = _tmp11_;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/video-support/AVIMetadataLoader.vala"
						g_propagate_error (error, _inner_error0_);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
						_g_free0 (name);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
						return NULL;
#line 942 "AVIMetadataLoader.c"
					}
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_tmp12_ = _tmp10_;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_tmp10_ = NULL;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					result = _tmp12_;
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_g_free0 (_tmp10_);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					_g_free0 (name);
#line 118 "../src/video-support/AVIMetadataLoader.vala"
					return result;
#line 956 "AVIMetadataLoader.c"
				}
			}
		}
#line 121 "../src/video-support/AVIMetadataLoader.vala"
		_tmp13_ = name;
#line 121 "../src/video-support/AVIMetadataLoader.vala"
		if (g_strcmp0 ("LIST", _tmp13_) == 0) {
#line 964 "AVIMetadataLoader.c"
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _result_ = NULL;
			AVIChunk* _tmp16_;
			AVIChunk* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			const gchar* _tmp20_;
#line 122 "../src/video-support/AVIMetadataLoader.vala"
			_tmp14_ = avi_chunk_read_name (chunk, &_inner_error0_);
#line 122 "../src/video-support/AVIMetadataLoader.vala"
			_tmp15_ = _tmp14_;
#line 122 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_tmp15_);
#line 122 "../src/video-support/AVIMetadataLoader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../src/video-support/AVIMetadataLoader.vala"
				g_propagate_error (error, _inner_error0_);
#line 122 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 122 "../src/video-support/AVIMetadataLoader.vala"
				return NULL;
#line 987 "AVIMetadataLoader.c"
			}
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_tmp16_ = avi_chunk_get_first_child_chunk (chunk);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_tmp17_ = _tmp16_;
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_tmp18_ = avi_metadata_loader_read_section (self, _tmp17_, &_inner_error0_);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_tmp19_ = _tmp18_;
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_avi_chunk_unref0 (_tmp17_);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			_result_ = _tmp19_;
#line 123 "../src/video-support/AVIMetadataLoader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/video-support/AVIMetadataLoader.vala"
				g_propagate_error (error, _inner_error0_);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 123 "../src/video-support/AVIMetadataLoader.vala"
				return NULL;
#line 1009 "AVIMetadataLoader.c"
			}
#line 124 "../src/video-support/AVIMetadataLoader.vala"
			_tmp20_ = _result_;
#line 124 "../src/video-support/AVIMetadataLoader.vala"
			if (NULL != _tmp20_) {
#line 125 "../src/video-support/AVIMetadataLoader.vala"
				result = _result_;
#line 125 "../src/video-support/AVIMetadataLoader.vala"
				_g_free0 (name);
#line 125 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1021 "AVIMetadataLoader.c"
			}
#line 121 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_result_);
#line 1025 "AVIMetadataLoader.c"
		}
#line 129 "../src/video-support/AVIMetadataLoader.vala"
		if (avi_chunk_is_last_chunk (chunk)) {
#line 130 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (name);
#line 130 "../src/video-support/AVIMetadataLoader.vala"
			break;
#line 1033 "AVIMetadataLoader.c"
		}
#line 132 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_next_chunk (chunk, &_inner_error0_);
#line 132 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 132 "../src/video-support/AVIMetadataLoader.vala"
			g_propagate_error (error, _inner_error0_);
#line 132 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (name);
#line 132 "../src/video-support/AVIMetadataLoader.vala"
			return NULL;
#line 1045 "AVIMetadataLoader.c"
		}
#line 110 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (name);
#line 1049 "AVIMetadataLoader.c"
	}
#line 134 "../src/video-support/AVIMetadataLoader.vala"
	result = NULL;
#line 134 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 1055 "AVIMetadataLoader.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 1072 "AVIMetadataLoader.c"
}

static GDateTime*
avi_metadata_loader_parse_date (AVIMetadataLoader* self,
                                const gchar* sdate)
{
	gint _tmp0_;
	gint _tmp1_;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint min = 0;
	gint sec = 0;
	gchar weekday[4] = {0};
	gchar monthstr[4] = {0};
	GDateTime* parsed_date = NULL;
	GDateTime* result;
#line 141 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 141 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (sdate != NULL, NULL);
#line 142 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = strlen (sdate);
#line 142 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/video-support/AVIMetadataLoader.vala"
	if (_tmp1_ == 0) {
#line 143 "../src/video-support/AVIMetadataLoader.vala"
		result = NULL;
#line 143 "../src/video-support/AVIMetadataLoader.vala"
		return result;
#line 1105 "AVIMetadataLoader.c"
	}
#line 151 "../src/video-support/AVIMetadataLoader.vala"
	if (g_ascii_isdigit (string_get (sdate, (glong) 0))) {
#line 1109 "AVIMetadataLoader.c"
		gchar* tmp = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gint _result_ = 0;
		const gchar* _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gint _tmp11_;
		GDateTime* _tmp12_;
#line 155 "../src/video-support/AVIMetadataLoader.vala"
		_tmp2_ = g_strdup (sdate);
#line 155 "../src/video-support/AVIMetadataLoader.vala"
		tmp = _tmp2_;
#line 156 "../src/video-support/AVIMetadataLoader.vala"
		_tmp3_ = tmp;
#line 156 "../src/video-support/AVIMetadataLoader.vala"
		g_strcanon (_tmp3_, "0123456789 ", ' ');
#line 157 "../src/video-support/AVIMetadataLoader.vala"
		sec = 0;
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		_tmp4_ = tmp;
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		_tmp11_ = sscanf (_tmp4_, "%d %d %d %d %d %d", &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		year = _tmp5_;
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		month = _tmp6_;
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		day = _tmp7_;
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		hour = _tmp8_;
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		min = _tmp9_;
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		sec = _tmp10_;
#line 158 "../src/video-support/AVIMetadataLoader.vala"
		_result_ = _tmp11_;
#line 159 "../src/video-support/AVIMetadataLoader.vala"
		if (_result_ < 5) {
#line 160 "../src/video-support/AVIMetadataLoader.vala"
			result = NULL;
#line 160 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (tmp);
#line 160 "../src/video-support/AVIMetadataLoader.vala"
			_g_date_time_unref0 (parsed_date);
#line 160 "../src/video-support/AVIMetadataLoader.vala"
			return result;
#line 1161 "AVIMetadataLoader.c"
		}
#line 163 "../src/video-support/AVIMetadataLoader.vala"
		_tmp12_ = g_date_time_new_utc (year, month, day, hour, min, (gdouble) sec);
#line 163 "../src/video-support/AVIMetadataLoader.vala"
		_g_date_time_unref0 (parsed_date);
#line 163 "../src/video-support/AVIMetadataLoader.vala"
		parsed_date = _tmp12_;
#line 151 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (tmp);
#line 1171 "AVIMetadataLoader.c"
	} else {
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		gint _tmp18_;
		GDateTime* _tmp19_;
#line 166 "../src/video-support/AVIMetadataLoader.vala"
		_tmp18_ = sscanf (sdate, "%3s %3s %d %d:%d:%d %d", weekday, monthstr, &_tmp13_, &_tmp14_, &_tmp15_, &_tmp16_, &_tmp17_);
#line 166 "../src/video-support/AVIMetadataLoader.vala"
		day = _tmp13_;
#line 166 "../src/video-support/AVIMetadataLoader.vala"
		hour = _tmp14_;
#line 166 "../src/video-support/AVIMetadataLoader.vala"
		min = _tmp15_;
#line 166 "../src/video-support/AVIMetadataLoader.vala"
		sec = _tmp16_;
#line 166 "../src/video-support/AVIMetadataLoader.vala"
		year = _tmp17_;
#line 166 "../src/video-support/AVIMetadataLoader.vala"
		if (7 != _tmp18_) {
#line 168 "../src/video-support/AVIMetadataLoader.vala"
			result = NULL;
#line 168 "../src/video-support/AVIMetadataLoader.vala"
			_g_date_time_unref0 (parsed_date);
#line 168 "../src/video-support/AVIMetadataLoader.vala"
			return result;
#line 1200 "AVIMetadataLoader.c"
		}
#line 170 "../src/video-support/AVIMetadataLoader.vala"
		_tmp19_ = g_date_time_new_local (year, (gint) avi_metadata_loader_month_from_string (self, (const gchar*) monthstr), day, hour, min, (gdouble) sec);
#line 170 "../src/video-support/AVIMetadataLoader.vala"
		_g_date_time_unref0 (parsed_date);
#line 170 "../src/video-support/AVIMetadataLoader.vala"
		parsed_date = _tmp19_;
#line 1208 "AVIMetadataLoader.c"
	}
#line 173 "../src/video-support/AVIMetadataLoader.vala"
	result = parsed_date;
#line 173 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 1214 "AVIMetadataLoader.c"
}

static GDateMonth
avi_metadata_loader_month_from_string (AVIMetadataLoader* self,
                                       const gchar* s)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label0 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label1 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label2 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label3 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label4 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label5 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label6 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label7 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label8 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label9 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label10 = 0;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	static GQuark _tmp2_label11 = 0;
#line 1248 "AVIMetadataLoader.c"
	GDateMonth result;
#line 176 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), 0);
#line 176 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (s != NULL, 0);
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = g_utf8_strdown (s, (gssize) -1);
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = _tmp0_;
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	g_free (_tmp1_);
#line 177 "../src/video-support/AVIMetadataLoader.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("jan")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1266 "AVIMetadataLoader.c"
			default:
			{
#line 179 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_JANUARY;
#line 179 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1273 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("feb")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1279 "AVIMetadataLoader.c"
			default:
			{
#line 181 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_FEBRUARY;
#line 181 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1286 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("mar")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1292 "AVIMetadataLoader.c"
			default:
			{
#line 183 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_MARCH;
#line 183 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1299 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("apr")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1305 "AVIMetadataLoader.c"
			default:
			{
#line 185 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_APRIL;
#line 185 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1312 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("may")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1318 "AVIMetadataLoader.c"
			default:
			{
#line 187 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_MAY;
#line 187 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1325 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("jun")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1331 "AVIMetadataLoader.c"
			default:
			{
#line 189 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_JUNE;
#line 189 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1338 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("jul")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1344 "AVIMetadataLoader.c"
			default:
			{
#line 191 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_JULY;
#line 191 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1351 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("aug")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1357 "AVIMetadataLoader.c"
			default:
			{
#line 193 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_AUGUST;
#line 193 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1364 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("sep")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1370 "AVIMetadataLoader.c"
			default:
			{
#line 195 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_SEPTEMBER;
#line 195 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1377 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("oct")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1383 "AVIMetadataLoader.c"
			default:
			{
#line 197 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_OCTOBER;
#line 197 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1390 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("nov")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1396 "AVIMetadataLoader.c"
			default:
			{
#line 199 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_NOVEMBER;
#line 199 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1403 "AVIMetadataLoader.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("dec")))) {
#line 177 "../src/video-support/AVIMetadataLoader.vala"
		switch (0) {
#line 1409 "AVIMetadataLoader.c"
			default:
			{
#line 201 "../src/video-support/AVIMetadataLoader.vala"
				result = G_DATE_DECEMBER;
#line 201 "../src/video-support/AVIMetadataLoader.vala"
				return result;
#line 1416 "AVIMetadataLoader.c"
			}
		}
	}
#line 203 "../src/video-support/AVIMetadataLoader.vala"
	result = G_DATE_BAD_MONTH;
#line 203 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 1424 "AVIMetadataLoader.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1445 "AVIMetadataLoader.c"
}

static GDateTime*
avi_metadata_loader_get_creation_date_time_for_avi (AVIMetadataLoader* self)
{
	AVIChunk* chunk = NULL;
	GFile* _tmp0_;
	AVIChunk* _tmp1_;
	GDateTime* timestamp = NULL;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
#line 206 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (IS_AVI_METADATA_LOADER (self), NULL);
#line 207 "../src/video-support/AVIMetadataLoader.vala"
	_tmp0_ = self->priv->file;
#line 207 "../src/video-support/AVIMetadataLoader.vala"
	_tmp1_ = avi_chunk_new (_tmp0_);
#line 207 "../src/video-support/AVIMetadataLoader.vala"
	chunk = _tmp1_;
#line 208 "../src/video-support/AVIMetadataLoader.vala"
	timestamp = NULL;
#line 1467 "AVIMetadataLoader.c"
	{
		AVIChunk* _tmp2_;
		AVIChunk* _tmp3_;
		gchar* sdate = NULL;
		AVIChunk* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 210 "../src/video-support/AVIMetadataLoader.vala"
		_tmp2_ = chunk;
#line 210 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_open_file (_tmp2_, &_inner_error0_);
#line 210 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 211 "../src/video-support/AVIMetadataLoader.vala"
		_tmp3_ = chunk;
#line 211 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_nonsection_skip (_tmp3_, (guint64) 12, &_inner_error0_);
#line 211 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1490 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 212 "../src/video-support/AVIMetadataLoader.vala"
		_tmp4_ = chunk;
#line 212 "../src/video-support/AVIMetadataLoader.vala"
		_tmp5_ = avi_metadata_loader_read_section (self, _tmp4_, &_inner_error0_);
#line 212 "../src/video-support/AVIMetadataLoader.vala"
		sdate = _tmp5_;
#line 212 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1501 "AVIMetadataLoader.c"
			goto __catch0_g_error;
		}
#line 213 "../src/video-support/AVIMetadataLoader.vala"
		_tmp6_ = sdate;
#line 213 "../src/video-support/AVIMetadataLoader.vala"
		if (NULL != _tmp6_) {
#line 1508 "AVIMetadataLoader.c"
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GDateTime* _tmp10_;
#line 214 "../src/video-support/AVIMetadataLoader.vala"
			_tmp7_ = sdate;
#line 214 "../src/video-support/AVIMetadataLoader.vala"
			_tmp8_ = string_strip (_tmp7_);
#line 214 "../src/video-support/AVIMetadataLoader.vala"
			_tmp9_ = _tmp8_;
#line 214 "../src/video-support/AVIMetadataLoader.vala"
			_tmp10_ = avi_metadata_loader_parse_date (self, _tmp9_);
#line 214 "../src/video-support/AVIMetadataLoader.vala"
			_g_date_time_unref0 (timestamp);
#line 214 "../src/video-support/AVIMetadataLoader.vala"
			timestamp = _tmp10_;
#line 214 "../src/video-support/AVIMetadataLoader.vala"
			_g_free0 (_tmp9_);
#line 1527 "AVIMetadataLoader.c"
		}
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		_g_free0 (sdate);
#line 1531 "AVIMetadataLoader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		e = _inner_error0_;
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		_inner_error0_ = NULL;
#line 217 "../src/video-support/AVIMetadataLoader.vala"
		_tmp11_ = e;
#line 217 "../src/video-support/AVIMetadataLoader.vala"
		_tmp12_ = _tmp11_->message;
#line 217 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:217: Error while reading AVI file: %s", _tmp12_);
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		_g_error_free0 (e);
#line 1551 "AVIMetadataLoader.c"
	}
	__finally0:
#line 209 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		_g_date_time_unref0 (timestamp);
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		_avi_chunk_unref0 (chunk);
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		g_clear_error (&_inner_error0_);
#line 209 "../src/video-support/AVIMetadataLoader.vala"
		return NULL;
#line 1566 "AVIMetadataLoader.c"
	}
	{
		AVIChunk* _tmp13_;
#line 221 "../src/video-support/AVIMetadataLoader.vala"
		_tmp13_ = chunk;
#line 221 "../src/video-support/AVIMetadataLoader.vala"
		avi_chunk_close_file (_tmp13_, &_inner_error0_);
#line 221 "../src/video-support/AVIMetadataLoader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1576 "AVIMetadataLoader.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 220 "../src/video-support/AVIMetadataLoader.vala"
		e = _inner_error0_;
#line 220 "../src/video-support/AVIMetadataLoader.vala"
		_inner_error0_ = NULL;
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		_tmp14_ = e;
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		_tmp15_ = _tmp14_->message;
#line 223 "../src/video-support/AVIMetadataLoader.vala"
		g_debug ("AVIMetadataLoader.vala:223: Error while closing AVI file: %s", _tmp15_);
#line 220 "../src/video-support/AVIMetadataLoader.vala"
		_g_error_free0 (e);
#line 1598 "AVIMetadataLoader.c"
	}
	__finally1:
#line 220 "../src/video-support/AVIMetadataLoader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../src/video-support/AVIMetadataLoader.vala"
		_g_date_time_unref0 (timestamp);
#line 220 "../src/video-support/AVIMetadataLoader.vala"
		_avi_chunk_unref0 (chunk);
#line 220 "../src/video-support/AVIMetadataLoader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 220 "../src/video-support/AVIMetadataLoader.vala"
		g_clear_error (&_inner_error0_);
#line 220 "../src/video-support/AVIMetadataLoader.vala"
		return NULL;
#line 1613 "AVIMetadataLoader.c"
	}
#line 225 "../src/video-support/AVIMetadataLoader.vala"
	result = timestamp;
#line 225 "../src/video-support/AVIMetadataLoader.vala"
	_avi_chunk_unref0 (chunk);
#line 225 "../src/video-support/AVIMetadataLoader.vala"
	return result;
#line 1621 "AVIMetadataLoader.c"
}

static void
value_avi_metadata_loader_init (GValue* value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	value->data[0].v_pointer = NULL;
#line 1629 "AVIMetadataLoader.c"
}

static void
value_avi_metadata_loader_free_value (GValue* value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (value->data[0].v_pointer) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		avi_metadata_loader_unref (value->data[0].v_pointer);
#line 1639 "AVIMetadataLoader.c"
	}
}

static void
value_avi_metadata_loader_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (src_value->data[0].v_pointer) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		dest_value->data[0].v_pointer = avi_metadata_loader_ref (src_value->data[0].v_pointer);
#line 1651 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1655 "AVIMetadataLoader.c"
	}
}

static gpointer
value_avi_metadata_loader_peek_pointer (const GValue* value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return value->data[0].v_pointer;
#line 1664 "AVIMetadataLoader.c"
}

static gchar*
value_avi_metadata_loader_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (collect_values[0].v_pointer) {
#line 1675 "AVIMetadataLoader.c"
		AVIMetadataLoader * object;
		object = collect_values[0].v_pointer;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1682 "AVIMetadataLoader.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1686 "AVIMetadataLoader.c"
		}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = avi_metadata_loader_ref (object);
#line 1690 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = NULL;
#line 1694 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return NULL;
#line 1698 "AVIMetadataLoader.c"
}

static gchar*
value_avi_metadata_loader_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	AVIMetadataLoader ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (!object_p) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1713 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (!value->data[0].v_pointer) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		*object_p = NULL;
#line 1719 "AVIMetadataLoader.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		*object_p = value->data[0].v_pointer;
#line 1723 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		*object_p = avi_metadata_loader_ref (value->data[0].v_pointer);
#line 1727 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return NULL;
#line 1731 "AVIMetadataLoader.c"
}

GParamSpec*
param_spec_avi_metadata_loader (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecAVIMetadataLoader* spec;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_AVI_METADATA_LOADER), NULL);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return G_PARAM_SPEC (spec);
#line 1750 "AVIMetadataLoader.c"
}

gpointer
value_get_avi_metadata_loader (const GValue* value)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AVI_METADATA_LOADER), NULL);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return value->data[0].v_pointer;
#line 1760 "AVIMetadataLoader.c"
}

void
value_set_avi_metadata_loader (GValue* value,
                               gpointer v_object)
{
	AVIMetadataLoader * old;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AVI_METADATA_LOADER));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	old = value->data[0].v_pointer;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (v_object) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AVI_METADATA_LOADER));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = v_object;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		avi_metadata_loader_ref (value->data[0].v_pointer);
#line 1782 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = NULL;
#line 1786 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (old) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		avi_metadata_loader_unref (old);
#line 1792 "AVIMetadataLoader.c"
	}
}

void
value_take_avi_metadata_loader (GValue* value,
                                gpointer v_object)
{
	AVIMetadataLoader * old;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AVI_METADATA_LOADER));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	old = value->data[0].v_pointer;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (v_object) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AVI_METADATA_LOADER));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = v_object;
#line 1813 "AVIMetadataLoader.c"
	} else {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		value->data[0].v_pointer = NULL;
#line 1817 "AVIMetadataLoader.c"
	}
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (old) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		avi_metadata_loader_unref (old);
#line 1823 "AVIMetadataLoader.c"
	}
}

static void
avi_metadata_loader_class_init (AVIMetadataLoaderClass * klass,
                                gpointer klass_data)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	avi_metadata_loader_parent_class = g_type_class_peek_parent (klass);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	((AVIMetadataLoaderClass *) klass)->finalize = avi_metadata_loader_finalize;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_type_class_adjust_private_offset (klass, &AVIMetadataLoader_private_offset);
#line 1837 "AVIMetadataLoader.c"
}

static void
avi_metadata_loader_instance_init (AVIMetadataLoader * self,
                                   gpointer klass)
{
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	self->priv = avi_metadata_loader_get_instance_private (self);
#line 3 "../src/video-support/AVIMetadataLoader.vala"
	self->priv->file = NULL;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	self->ref_count = 1;
#line 1850 "AVIMetadataLoader.c"
}

static void
avi_metadata_loader_finalize (AVIMetadataLoader * obj)
{
	AVIMetadataLoader * self;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AVI_METADATA_LOADER, AVIMetadataLoader);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_signal_handlers_destroy (self);
#line 3 "../src/video-support/AVIMetadataLoader.vala"
	_g_object_unref0 (self->priv->file);
#line 1863 "AVIMetadataLoader.c"
}

static GType
avi_metadata_loader_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_avi_metadata_loader_init, value_avi_metadata_loader_free_value, value_avi_metadata_loader_copy_value, value_avi_metadata_loader_peek_pointer, "p", value_avi_metadata_loader_collect_value, "p", value_avi_metadata_loader_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AVIMetadataLoaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) avi_metadata_loader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AVIMetadataLoader), 0, (GInstanceInitFunc) avi_metadata_loader_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType avi_metadata_loader_type_id;
	avi_metadata_loader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AVIMetadataLoader", &g_define_type_info, &g_define_type_fundamental_info, 0);
	AVIMetadataLoader_private_offset = g_type_add_instance_private (avi_metadata_loader_type_id, sizeof (AVIMetadataLoaderPrivate));
	return avi_metadata_loader_type_id;
}

GType
avi_metadata_loader_get_type (void)
{
	static volatile gsize avi_metadata_loader_type_id__once = 0;
	if (g_once_init_enter (&avi_metadata_loader_type_id__once)) {
		GType avi_metadata_loader_type_id;
		avi_metadata_loader_type_id = avi_metadata_loader_get_type_once ();
		g_once_init_leave (&avi_metadata_loader_type_id__once, avi_metadata_loader_type_id);
	}
	return avi_metadata_loader_type_id__once;
}

gpointer
avi_metadata_loader_ref (gpointer instance)
{
	AVIMetadataLoader * self;
	self = instance;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	return instance;
#line 1899 "AVIMetadataLoader.c"
}

void
avi_metadata_loader_unref (gpointer instance)
{
	AVIMetadataLoader * self;
	self = instance;
#line 1 "../src/video-support/AVIMetadataLoader.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		AVI_METADATA_LOADER_GET_CLASS (self)->finalize (self);
#line 1 "../src/video-support/AVIMetadataLoader.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1913 "AVIMetadataLoader.c"
	}
}

